package net.refractions.udig.catalog.internal.postgis;

import java.io.IOException;

import org.geotools.data.jdbc.ConnectionPool;
import org.geotools.data.postgis.PostgisDataStore;
import org.geotools.data.postgis.PostgisDataStoreFactory;

/**
 * Subclass of the PostgisDataStore factory which creates the correct 
 * UDIGPostGISDataStore instannce.
 * 
 * @author Justin Deoliveira,Refractions Research Inc.,jdeolive@refractions.net
 *
 */
public class UDIGPostGISDataStoreFactory extends PostgisDataStoreFactory {
	
	@Override
	protected PostgisDataStore createDataStoreInternal(ConnectionPool pool) throws IOException {
		return new UDIGPostGISDataStore(pool);
	}
	
	@Override
	protected PostgisDataStore createDataStoreInternal(
		ConnectionPool pool, String namespace
	) throws IOException {
		return new UDIGPostGISDataStore(pool, namespace);
	}
}