/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.internal.ui;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;

import net.refractions.udig.catalog.ui.DataSourceSelectionPage;
import net.refractions.udig.internal.ui.WorkflowAction;

import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public class URLWorkflowAction implements WorkflowAction {

    List<String> compatibleWizardIDs = null;
    
     
    public void handleDrop( List<String> compatibileWizardIDs, Object data ) {
        URL url = null;
        if (data instanceof String) {
            String[] strings = ((String)data).split("\n"); //$NON-NLS-1$
            try {
                url = new URL(strings[0]);
            } catch (MalformedURLException e) {
                // TODO Catch e
            }
        }
        if (data instanceof URL) {
            url = (URL) data;
        }
        
        this.compatibleWizardIDs = compatibileWizardIDs;
		URLWizard wizard = new URLWizard();
		
		Shell shell = new Shell(Display.getDefault());
        HeadlessWizardDialog dialog = new HeadlessWizardDialog(shell,wizard);
        dialog.setSelection(new StructuredSelection(url));
		
		dialog.setBlockOnOpen(true);
		dialog.open();
		dialog.runHeadless();
		
		if (!shell.isDisposed())
			shell.dispose();
	}
    
    class URLWizard extends CatalogImportWizard {
        
        @Override
        protected WizardPage[] getPrimaryPages() {
            
            DataSourceSelectionPage page = new DataSourceSelectionPage();
            page.select(compatibleWizardIDs);
            
            return new WizardPage[] { page };

        }
        
    }
}
