/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.memory.internal;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.geotools.data.FeatureReader;
import org.geotools.data.memory.MemoryDataStore;
import org.geotools.feature.Feature;
import org.geotools.feature.FeatureCollection;
import org.geotools.feature.FeatureType;

/**
 *  summary sentence.
 * <p>
 * Paragraph ...
 * </p><p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p><p>
 * Example:<pre><code>
 * AnotherMemoryDataStore x = new AnotherMemoryDataStore( ... );
 * TODO code example
 * </code></pre>
 * </p>
 * @author mleslie
 * @since 0.6.0
 */
public class AnotherMemoryDataStore extends MemoryDataStore {
    List<MemoryServiceListener> list = new ArrayList<MemoryServiceListener>();

    /**
     * Construct <code>AnotherMemoryDataStore</code>.
     *
     */
    public AnotherMemoryDataStore() {
        super();
    }

    /**
     * Construct <code>AnotherMemoryDataStore</code>.
     *
     * @param collection
     */
    public AnotherMemoryDataStore( FeatureCollection collection ) {
        super(collection);
    }

    /**
     * Construct <code>AnotherMemoryDataStore</code>.
     *
     * @param array
     */
    public AnotherMemoryDataStore( Feature[] array ) {
        super(array);
    }

    /**
     * Construct <code>AnotherMemoryDataStore</code>.
     *
     * @param reader
     * @throws IOException
     */
    public AnotherMemoryDataStore( FeatureReader reader ) throws IOException {
        super(reader);
    }
    
    /**
     * TODO summary sentence for addFeatureListener ...
     * 
     * @param listener
     */
    public void addListener(MemoryServiceListener listener) {
        this.list.add(listener);
    }
    
    /**
     * TODO summary sentence for removeFeatureListener ...
     * 
     * @param listener
     * @return true if removed
     */
    public boolean removeListener(MemoryServiceListener listener) {
        return this.list.remove(listener);
    }
    
    public void createSchema(FeatureType featureType) throws IOException {
       super.createSchema(featureType);
       for(MemoryServiceListener listener : this.list) {
           listener.schemaChanged();
       }
    }

}
