package net.refractions.udig.catalog.memory.internal;

import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import net.refractions.udig.catalog.IService;
import net.refractions.udig.catalog.ServiceExtension;
import net.refractions.udig.catalog.memory.MemoryService;

public class MemoryServiceExtensionImpl implements ServiceExtension {

	public IService createService(URL id, Map<String, Serializable> params) {
		  if( params.containsKey("scratch")){ //$NON-NLS-1$
	            return new MemoryServiceImpl();
	        }
	        return null;
	}

	public Map<String, Serializable> createParams(URL url) {
		 if( url != null && url.toExternalForm().startsWith( MemoryService.URL.toExternalForm())){
            Map<String,Serializable> map = new HashMap<String,Serializable>();
            map.put( "scratch", url ); //$NON-NLS-1$
            return map;            
        }
        return null;
	}
	
}