/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.catalog.ui;

import org.eclipse.jface.viewers.DecoratingLabelProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

/**
 * Provides Tree view of the Registry.
 * <p>
 * Supports the following:
 * <ul>
 * <li>List
 * <li>IService
 * <li>IGeoReference
 * <li>ICatalog
 * <li>String
 * </ul>
 * </p>
 * <p>
 * To display a message or status please use a Collections.singletonList( "hello world" ).
 * </p>
 * 
 * @author jeichar
 * @since 0.3
 */
public class CatalogTreeViewerSimple extends TreeViewer {

    /**
     * Construct <code>CatalogTreeViewer</code>.
     * 
     * @param parent
     */
    public CatalogTreeViewerSimple( Composite parent ) {
        this(parent, false);
    }
    /**
     * Construct <code>CatalogTreeViewer</code>.
     * 
     * @param parent
     */
    public CatalogTreeViewerSimple( Composite parent, boolean titles ) {
        super(parent, SWT.MULTI | SWT.V_SCROLL | SWT.BORDER );                       
        setContentProvider( new ResolveContentProviderSimple() ); // simple blocking content
                                                                    // provider
        //IDecoratorManager manager = PlatformUI.getWorkbench().getDecoratorManager();
        if( titles ){            
            setLabelProvider(
                new DecoratingLabelProvider(
                    new ResolveLabelProviderSimple(),
                    new ResolveTitlesDecorator()
                )
            );
        }
        else {
            setLabelProvider( new ResolveLabelProviderSimple() );
        }
        //setInput( CatalogPlugin.getDefault().getLocalCatalog() );
    }

}