/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.ui;

import org.geotools.data.FeatureSource;

/**
 * Provides support for FeatureSource processing.
 * 
 * @author jgarnett
 * @since 0.3
 */
public abstract class FeatureSourceOp extends Op {
    /** <code>EXTENSION</code> field */
    public static final String EXTENSION = "process"; //$NON-NLS-1$

    /**
     * Performs an opperation on schema producing a new Schema.
     * <p>
     * <b>Precondition:</b>
     * <ul>
     * <li>FeatureSource is selected (or indicated) by the end user
     * <li>a user interface allow the end user to modify getParams is persented
     * </ul>
     * </p>
     * <p>
     * No postconditions are assumed at this time, any "result" is expected
     * to be offline (creation of a validation report for example).
     * </p>
     * <p>
     * Note a 
     * @param source
     * @throws Exception if opperation cannot be performed
     */ 
    public abstract void op( FeatureSource source ) throws Exception;
    
}
