/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.catalog.ui.op;

import java.text.MessageFormat;

import net.refractions.udig.catalog.internal.ui.Policy;
import net.refractions.udig.catalog.ui.FeatureSourceOp;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.geotools.data.FeatureReader;
import org.geotools.data.FeatureSource;

/**
 * Provides ...TODO summary sentence
 * <p>
 * TODO Description
 * </p><p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p><p>
 * Example Use:<pre><code>
 * CountOp x = new CountOp( ... );
 * TODO code example
 * </code></pre>
 * </p>
 * @author jeichar
 * @since 0.3
 */
public class CountOp extends FeatureSourceOp {

    /**
     * Counts the features in the feature source
     * 
     * @see net.refractions.udig.catalog.ui.FeatureSourceOp#op(org.geotools.data.FeatureSource)
     * @param source
     * @throws Exception
     */
    public void op( FeatureSource source ) throws Exception {
        FeatureReader reader=source.getFeatures().reader();
        int i=0;
        while( reader.hasNext()){
            i++;
            reader.next();
        }
        reader.close();
        MessageFormat formatter = new MessageFormat(Policy.bind("CountOp.numberOfFeatures")); //$NON-NLS-1$
        MessageDialog.openInformation(Display.getDefault().getActiveShell(),
                Policy.bind("CountOp.featureCount"), formatter.format(i)); //$NON-NLS-1$
    }

}
