package net.refractions.udig.internal.ui;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerDropAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.TransferData;

public class UDIGDropAdapter extends ViewerDropAdapter {

	/** the source object **/
	Object sourceData;

	UDIGDropHandler handler;

	private Object target;
	
	public UDIGDropAdapter(Viewer viewer, Object destination) {
		super(viewer);
		handler = new UDIGDropHandler(this);
		handler.setDestination(destination);
	}

	@Override
	public void dragEnter(DropTargetEvent event) {
		handler.dragEnter(event);
	}
	
	@Override
	public void dragOperationChanged(DropTargetEvent event) {
		handler.dragOperationChanged(event);
	}
    
    @Override
    public void dragOver( DropTargetEvent event ) {
        handler.dragOver(event);
    }

    @Override
    public void dropAccept( DropTargetEvent event ) {
        handler.dropAccept(event);
    }

    @Override
	public void drop(DropTargetEvent event) {
		handler.drop(event);
		target=super.determineTarget(event);
		super.drop(event);
	}
	
	@Override
	public boolean performDrop(Object data) {
		Object target=getCurrentTarget();
		if( target==null )
			target=this.target;
		handler.setTarget(target);
		handler.setLocation(getCurrentLocation());
		return handler.performDrop(data);
	}
	
	@Override
	public boolean validateDrop(Object target, int operation, TransferData transferType) {
		handler.setTarget(getCurrentTarget());
		handler.setLocation(getCurrentLocation());
		return handler.validateDrop(target, operation, transferType);
	}

}