package net.refractions.udig.internal.ui;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.edit.ui.dnd.LocalTransfer;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.dnd.ByteArrayTransfer;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.HTMLTransfer;
import org.eclipse.swt.dnd.RTFTransfer;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.dnd.TransferData;

public class UDigByteAndLocalTransfer extends ByteArrayTransfer{
	private static UDigByteAndLocalTransfer _instance = new UDigByteAndLocalTransfer();

	static final String CFSTR_INETURL = "UniformResourceLocator"; //$NON-NLS-1$

	private static final int CFSTR_INETURLID = Transfer
			.registerType(CFSTR_INETURL);

	private long startTime;

	private Object object;

    @Override
    public boolean isSupportedType( TransferData transferData ) {
        return super.isSupportedType(transferData);
    }

	public UDigByteAndLocalTransfer() {
        System.out.println(CFSTR_INETURLID);
		// do nothing.
	}

	public static UDigByteAndLocalTransfer getInstance() {

		return _instance;
	}

	protected int[] getTypeIds() {

		return new int[] { CFSTR_INETURLID };
	}

	public String[] getTypeNames() {

		return new String[] { CFSTR_INETURL };
	}

	@Override
	public TransferData[] getSupportedTypes() {
		return super.getSupportedTypes();
	}
	
	@SuppressWarnings("unchecked") //$NON-NLS-1$
	@Override
	public void javaToNative(Object object, TransferData transferData) {

	    startTime = System.currentTimeMillis();
	    if( object instanceof IStructuredSelection){
	    	IStructuredSelection selection=(IStructuredSelection) object;
	    	List<Object> elements=new ArrayList<Object>();
	    	for (Iterator<Object> iter = selection.iterator(); iter.hasNext();) {
				elements.add(iter.next());
			}
	    	object=elements.toArray();
	    }
	    this.object = object;
	    if (transferData != null)
	    {
	      super.javaToNative(String.valueOf(startTime).getBytes(), transferData);
	    }
	}

	/**
	 * This implementation of <code>nativeToJava</code> converts a platform
	 * specific representation of a URL and optionally, a title to a java
	 * <code>String[]</code>. For additional information see
	 * <code>Transfer#nativeToJava</code>.
	 * 
	 * @param transferData
	 *            the platform specific representation of the data to be been
	 *            converted
	 * @return a java <code>String[]</code> containing a URL and optionally a
	 *         title if the conversion was successful; otherwise null
	 */
    public Object nativeToJava(TransferData transferData) {
        
        byte[] bytes = (byte[])super.nativeToJava(transferData); 
        if (bytes == null) return null;
        
        try
        {
          long startTime = Long.valueOf(new String(bytes)).longValue();
          return this.startTime == startTime ? object : null;
        }
        catch (NumberFormatException exception)
        {
            InputStreamReader reader = new InputStreamReader(
                    new ByteArrayInputStream(bytes));
            StringBuffer buf = new StringBuffer();
            char[] chars = new char[bytes.length / 2];
            try {
                reader.read(chars);
            } catch (IOException e) {
                UiPlugin.log("Error reading transfer data", e);
            }
            buf.append(chars);
            return buf.toString().trim();
        }

		
	}

	boolean checkURL(Object object) {
		if (object == null || !(object instanceof String[])
				|| ((String[]) object).length == 0)
			return false;
		String[] strings = (String[]) object;
		if (strings[0] == null || strings[0].length() == 0)
			return false;
		try {
			new URL(strings[0]);
		} catch (java.net.MalformedURLException e) {
			return false;
		}
		return true;
	}

	protected boolean validate(Object object) {
		return checkURL(object);
	}
}