/*
 * Created on Mar 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package net.refractions.udig.internal.ui.operations;

import java.util.ArrayList;
import java.util.List;

import net.refractions.udig.ui.operations.OpAction;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.viewers.ISelection;

/**
 * A category of operations.  Listens to the contained actions and disables it self
 * if none of its contained Actions are visible.
 * 
 * @author jeichar
 */
public class OperationCategory extends MenuManager{
	List<OpAction> actions=new ArrayList<OpAction>();
	MenuManager manager;
	
	/**
	 * new instance 
	 */
	public OperationCategory(IConfigurationElement element) {
		super( element.getAttribute("name"), element.getAttribute("id")); //$NON-NLS-1$ //$NON-NLS-2$
	}
	
	public MenuManager createContextMenu(){
		manager=new MenuManager(getMenuText(), getId());
		for( OpAction action:actions){
			if( action.isEnabled() ){
				manager.add( action );
			}
		}
		return manager;
	}
	
	/**
	 * All actions added must be instances of OpAction
	 * @see org.eclipse.jface.action.ContributionManager#add(org.eclipse.jface.action.IAction)
	 */
	public void add(IAction action) {
		assert action instanceof OpAction;
		actions.add((OpAction) action);
        ((OpAction)action).setCategory(this);
		super.add(action);
	}

	/**
	 * @param selection
	 */
	public void setSelection(ISelection selection) {
		for(OpAction action:actions){
			action.selectionChanged(null, selection);
		}	
	}
    
    /**
     * Contained OpActions call this to notify the category when its enablement has changed.
     */
    public void enablementChanged( ){
        boolean enabled=false;
        for(OpAction action: actions){
            if( action.isEnabled() ){
                enabled=true;
                break;
            }
        }
        if( getMenu().getParentItem()!=null ){
            getMenu().getParentItem().setEnabled(enabled);
        }
    }
    
    /**
     * gets all the Operation actions in the category.
     */
    public List<OpAction> getActions() {
        return actions;
    }
}
