/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package net.refractions.udig.printing.model.impl;

import java.awt.Graphics2D;
import java.util.Collection;
import java.util.List;

import net.refractions.udig.printing.model.Box;
import net.refractions.udig.printing.model.Connection;
import net.refractions.udig.printing.model.ModelPackage;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Box</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link net.refractions.udig.printing.model.impl.BoxImpl#getSourceConnections <em>Source Connections</em>}</li>
 *   <li>{@link net.refractions.udig.printing.model.impl.BoxImpl#getTargetConnections <em>Target Connections</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class BoxImpl extends ElementImpl implements Box {
	/**
	 * The cached value of the '{@link #getSourceConnections() <em>Source Connections</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getSourceConnections()
	 * @generated
	 * @ordered
	 */
    protected EList sourceConnections = null;

	/**
	 * The cached value of the '{@link #getTargetConnections() <em>Target Connections</em>}' reference list.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getTargetConnections()
	 * @generated
	 * @ordered
	 */
    protected EList targetConnections = null;

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected BoxImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getBox();
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public List getSourceConnections() {
		if (sourceConnections == null) {
			sourceConnections = new EObjectResolvingEList(Connection.class, this, ModelPackage.BOX__SOURCE_CONNECTIONS);
		}
		return sourceConnections;
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public List getTargetConnections() {
		if (targetConnections == null) {
			targetConnections = new EObjectResolvingEList(Connection.class, this, ModelPackage.BOX__TARGET_CONNECTIONS);
		}
		return targetConnections;
	}

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public void draw(Graphics2D graphics, IProgressMonitor monitor) {
//        Rectangle clipBounds = graphics.getClipBounds();
//        graphics.setStroke(new BasicStroke(1));
//        graphics.drawRect(clipBounds.x, clipBounds.y, clipBounds.width, clipBounds.height);
        
    }

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ModelPackage.BOX__LOCATION:
				return getLocation();
			case ModelPackage.BOX__SIZE:
				return getSize();
			case ModelPackage.BOX__SOURCE_CONNECTIONS:
				return getSourceConnections();
			case ModelPackage.BOX__TARGET_CONNECTIONS:
				return getTargetConnections();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ModelPackage.BOX__LOCATION:
				setLocation((Point)newValue);
				return;
			case ModelPackage.BOX__SIZE:
				setSize((Dimension)newValue);
				return;
			case ModelPackage.BOX__SOURCE_CONNECTIONS:
				getSourceConnections().clear();
				getSourceConnections().addAll((Collection)newValue);
				return;
			case ModelPackage.BOX__TARGET_CONNECTIONS:
				getTargetConnections().clear();
				getTargetConnections().addAll((Collection)newValue);
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ModelPackage.BOX__LOCATION:
				setLocation(LOCATION_EDEFAULT);
				return;
			case ModelPackage.BOX__SIZE:
				setSize(SIZE_EDEFAULT);
				return;
			case ModelPackage.BOX__SOURCE_CONNECTIONS:
				getSourceConnections().clear();
				return;
			case ModelPackage.BOX__TARGET_CONNECTIONS:
				getTargetConnections().clear();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ModelPackage.BOX__LOCATION:
				return LOCATION_EDEFAULT == null ? location != null : !LOCATION_EDEFAULT.equals(location);
			case ModelPackage.BOX__SIZE:
				return SIZE_EDEFAULT == null ? size != null : !SIZE_EDEFAULT.equals(size);
			case ModelPackage.BOX__SOURCE_CONNECTIONS:
				return sourceConnections != null && !sourceConnections.isEmpty();
			case ModelPackage.BOX__TARGET_CONNECTIONS:
				return targetConnections != null && !targetConnections.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	public void add(Connection connection) {
		if (connection == null) {
			throw new IllegalArgumentException("Connection cannot be null"); //$NON-NLS-1$
		}
		
		if (connection.getTarget() == connection.getSource()) {
			throw new IllegalArgumentException("Connection source and target cannot be the same"); //$NON-NLS-1$
		}
		
		if (connection.getSource() == this) {
			getSourceConnections().add(connection);
		} else if (connection.getTarget() == this) {
			getTargetConnections().add(connection);
		}
	}
	public void remove(Connection connection) {
		if (connection == null) {
			throw new IllegalArgumentException("Connection cannot be null"); //$NON-NLS-1$
		}
		
		if (connection.getSource() == this) {
			getSourceConnections().remove(connection);
		} else if (connection.getTarget() == this) {
			getTargetConnections().remove(connection);
		}
	}
} //BoxImpl
