package net.refractions.udig.printing.ui;

import net.refractions.udig.printing.model.Box;

import org.eclipse.jface.resource.ImageDescriptor;

/**
 * Interface for creating new instances of Boxes.
 * 
 * @author rgould
 */
public interface BoxFactory {

	/**
	 * Instantiates a new instance of a Box
	 */
	public Box createBox();
	
	/**
	 * Returns the name of the Box type that this factory can create. It should
	 * be human-readable.
	 */
	public String getName();

	/**
	 * A description of what this type of Box can do. It should be human-readable.
	 */
	public String getDescription();

	/**
	 * @return The instance type of the box that this factory creates.
	 */
	public Class getType();

	/**
	 * 16x16 pixels image
	 */
	public ImageDescriptor getSmallImage();

	/**
	 * 24x24 pixels image
	 */
	public ImageDescriptor getLargeImage();
}
