package net.refractions.udig.printing.ui.internal.editor.commands;

import java.util.Iterator;

import net.refractions.udig.printing.model.Box;
import net.refractions.udig.printing.model.Connection;
import net.refractions.udig.printing.model.ModelFactory;
import net.refractions.udig.printing.ui.Policy;

import org.eclipse.gef.commands.Command;

public class ConnectionCreateCommand extends Command {

	private Box source;
	private Box target;
	private Connection connection;

	public ConnectionCreateCommand(Box source) {
		super();
		if (source == null) {
			throw new IllegalArgumentException(Policy.bind("ConnectionCreateCommand.error.sourceNull")); //$NON-NLS-1$
		}
		this.source = source;
	}
	
	public boolean canExecute() {
		if (source.equals(target)) {
			return false;
		}
		Iterator iter = source.getSourceConnections().iterator();
		while(iter.hasNext()) {
			Connection connection = (Connection) iter.next();
			
			if (connection.getTarget().equals(target)) {
				return false;
			}
		}
		return true;
	}
	public void execute() {
		connection = ModelFactory.eINSTANCE.createConnection();
		connection.setSource(source);
		connection.setTarget(target);
	}
	public void redo() {
		connection.reconnect();
	}
	public void setTarget(Box target) {
		if (target == null) {
			throw new IllegalArgumentException(Policy.bind("ConnectionCreateCommand.error.targetNull")); //$NON-NLS-1$
		}
		this.target = target;
	}
		
	public void undo() {
		connection.disconnect();
	}
}
