/**
 * <copyright></copyright> $Id: ProjectPlugin.java 15336 2005-08-15 18:40:30Z jdeolive $
 */
package net.refractions.udig.project.internal;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import net.refractions.udig.project.internal.impl.ProjectRegistryImpl;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.EMFPlugin;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.xmi.XMLResource;
import org.osgi.framework.BundleContext;

/**
 * This is the central singleton for the Project model plugin.
 * <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * @generated
 */
public final class ProjectPlugin extends EMFPlugin {
	/** Plugin ID */
	public final static String ID = "net.refractions.udig.project"; //$NON-NLS-1$

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

    /**
     * Keep track of the singleton.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public static final ProjectPlugin INSTANCE = new ProjectPlugin();

	/**
	 * Keep track of the singleton. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	static Implementation plugin;

    /**
     * Create the instance.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
	public ProjectPlugin() {
        super(new ResourceLocator [] {});
    }

    /**
     * Returns the singleton instance of the Eclipse plugin.
     * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
     * @return the singleton instance.
     * @generated
     */
	public ResourceLocator getPluginResourceLocator() {
        return plugin;
    }

    /**
     * Returns the singleton instance of the Eclipse plugin.
     * <!-- begin-user-doc --> <!--
	 * end-user-doc -->
     * @return the singleton instance.
     * @generated
     */
	public static Implementation getPlugin() {
        return plugin;
    }

	/**
     * TODO Purpose of net.refractions.udig.project.internal <p> </p>
     * @author   Jesse
     * @since   1.0.0
     * @generated
     */
	public static class Implementation extends EclipsePlugin {

        /**
         * Creates an instance.
         * <!-- begin-user-doc --> <!-- end-user-doc -->
         * @generated
         */
		public Implementation() {
            super();

            // Remember the static instance.
            //
            plugin = this;
        }
    				                                    											                                		/**
		 * @see org.eclipse.core.runtime.Plugin#start(org.osgi.framework.BundleContext)
		 */
		public void start(BundleContext context) throws Exception {
			super.start(context);
			Policy.localize("net.refractions.udig.project.internal.messages"); //$NON-NLS-1$
		}

		protected static final String ENCODING = "UTF-8"; //$NON-NLS-1$

		/**
         * EMF save parameters.
         * @uml.property   name="saveOptions"
         * @uml.associationEnd   qualifier="key:java.lang.Object java.lang.String"
         */
		public Map<String, String> saveOptions = new HashMap<String, String>();
		{
			saveOptions.put(XMLResource.OPTION_ENCODING, ENCODING);
		}

		/**
		 * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
		 */
		public void stop(BundleContext context) throws Exception {
            turnOffEvents();
			List resources = getProjectRegistry().eResource().getResourceSet()
					.getResources();
			for (Iterator iter = resources.iterator(); iter.hasNext();) {
				Resource resource = (Resource) iter.next();
				if (resource.isModified())
					resource.save(saveOptions);
			}
			Policy.cleanup();
			super.stop(context);
		}

		ProjectRegistry projectRegistry;

		/**
         * @see net.refractions.udig.project.internal.ProjectFactory#getProjectRegistry()
         * @uml.property   name="projectRegistry"
         */
		public ProjectRegistry getProjectRegistry() {
			if (projectRegistry == null) {
                synchronized(ProjectRegistry.class){
					if (projectRegistry == null) {
                        projectRegistry=ProjectRegistryImpl.load();
					}
                }
			}
			return projectRegistry;
		}
        
        public void turnOffEvents() {
            Iterator allIter=getProjectRegistry().eResource().getResourceSet().getAllContents();
            while( allIter.hasNext() ){
            	Object tmp=allIter.next();
            	Notifier obj=(Notifier) tmp;
                obj.eSetDeliver(false);
            }
        }


	}
    
    /**
     * Writes an info log in the plugin's log.
     * @param message
     */
    public static void log(String message) {
        log(message, null);
    }   

    /**
     * Writes an info log in the plugin's log.
     * <p>
     * This should be used for user level messages.
     * </p>
     */
    public static void log( String message, Throwable e) {
        getPlugin().getLog().log(new Status(IStatus.INFO, ID, 0, message==null?"":message, e)); //$NON-NLS-1$
    }
    /**
     * Messages that only engage if getDefault().isDebugging()
     * <p>
     * It is much prefered to do this:<pre><code>
     * private static final String RENDERING = "net.refractions.udig.project/render/trace";
     * if( ProjectUIPlugin.getDefault().isDebugging() && "true".equalsIgnoreCase( RENDERING ) ){
     *      System.out.println( "your message here" );
     * }
     */
    public static void trace( String message, Throwable e) {
        if( getPlugin().isDebugging() ) {
            if( message != null ) System.out.println( message );
            if( e != null ) e.printStackTrace();
        }
    }
    /**
     * Performs the Platform.getDebugOption true check on the provided trace
     * <p>
     * Note: ProjectUIPlugin.getDefault().isDebugging() must also be on.
     * <ul>
     * <li>Trace.RENDER - trace rendering progress
     * </ul>
     * </p> 
     * @param trace currently only RENDER is defined
     */
    public static boolean isDebugging( final String trace ){
        return getPlugin().isDebugging() &&
            "true".equalsIgnoreCase(Platform.getDebugOption(trace)); //$NON-NLS-1$
    
    }
}
