/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.project.internal.commands;

import java.text.MessageFormat;

import net.refractions.udig.project.command.AbstractCommand;
import net.refractions.udig.project.command.MapCommand;
import net.refractions.udig.project.command.UndoableCommand;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.Policy;

import org.eclipse.core.runtime.IProgressMonitor;


/**
 * TODO Purpose of net.refractions.udig.project.internal.commands <p> </p>
 * @author   Jesse
 * @since   1.0.0
 */
public class DeleteLayerCommand extends AbstractCommand implements
		UndoableCommand {

	private Layer layer;

	private int index;

	private Map map;

	/**
	 * Construct <code>DeleteLayerCommand</code>.
	 * 
	 * @param map
	 */
	public DeleteLayerCommand(Layer layer) {
		this.map = layer.getContextModel().getMap();
		this.layer = layer;
	}

	/**
	 * @see net.refractions.udig.project.command.UndoableCommand#rollback()
	 */
	public void rollback(IProgressMonitor monitor) throws Exception {
		map.getContextModel().getLayers().add(index, layer);
	}

	/**
	 * @see net.refractions.udig.project.command.MapCommand#run()
	 */
	public void run(IProgressMonitor monitor) throws Exception {
		map.getContextModel().getLayers().indexOf(layer);
		if (layer.getContextModel().getLayers().size() == 1)
			layer.getContextModel().getMap().getRenderManagerInternal()
					.getRenderExecutor().getContext().clearImage();
		layer.getContextModel().getLayers().remove(layer);
	}

	/**
	 * @see net.refractions.udig.project.command.MapCommand#copy()
	 */
	public MapCommand copy() {
		return new DeleteLayerCommand(layer);
	}

	/**
	 * @see net.refractions.udig.project.command.MapCommand#getName()
	 */
	public String getName() {
		return MessageFormat
				.format(
						Policy.bind("DeleteLayerCommand.deleteLayer"), new Object[] { layer.getName() }); //$NON-NLS-1$
	}

}
