/**
 * <copyright></copyright> $Id: LayerImpl.java 16028 2005-10-04 22:39:11Z aalam $
 */
package net.refractions.udig.project.internal.impl;

import java.awt.geom.AffineTransform;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import net.refractions.udig.catalog.CatalogPlugin;
import net.refractions.udig.catalog.ICatalog;
import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.catalog.IGeoResourceInfo;
import net.refractions.udig.catalog.IResolve;
import net.refractions.udig.catalog.IResolveChangeEvent;
import net.refractions.udig.catalog.IResolveDelta;
import net.refractions.udig.catalog.IService;
import net.refractions.udig.catalog.util.SearchIDDeltaVisitor;
import net.refractions.udig.project.IBlackboard;
import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.ILayerListener;
import net.refractions.udig.project.IMap;
import net.refractions.udig.project.LayerEvent;
import net.refractions.udig.project.internal.CatalogRef;
import net.refractions.udig.project.internal.ContextModel;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Policy;
import net.refractions.udig.project.internal.ProjectFactory;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;
import net.refractions.udig.project.internal.SimpleBlackboard;
import net.refractions.udig.project.internal.StyleBlackboard;
import net.refractions.udig.ui.palette.ColourScheme;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EDataTypeUniqueEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.util.ListenerList;
import org.geotools.data.DefaultQuery;
import org.geotools.data.FeatureEvent;
import org.geotools.data.FeatureListener;
import org.geotools.data.FeatureSource;
import org.geotools.data.Query;
import org.geotools.feature.FeatureType;
import org.geotools.filter.BBoxExpression;
import org.geotools.filter.Filter;
import org.geotools.filter.FilterFactory;
import org.geotools.filter.FilterType;
import org.geotools.filter.GeometryFilter;
import org.geotools.geometry.JTS;
import org.geotools.geometry.JTS.ReferencedEnvelope;
import org.geotools.referencing.CRS;
import org.geotools.referencing.FactoryFinder;
import org.geotools.referencing.crs.DefaultGeographicCRS;
import org.geotools.referencing.operation.GeneralMatrix;
import org.opengis.referencing.crs.CoordinateReferenceSystem;
import org.opengis.referencing.operation.MathTransform;
import org.opengis.referencing.operation.MathTransform2D;

import com.vividsolutions.jts.geom.Envelope;

/**
 * Standard implementation of a Layer.
 * <p>
 * </p>
 * 
 * @author Jesse
 * @since 1.0.0
 * @generated
 */
public class LayerImpl extends EObjectImpl implements Layer {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/** <code>IDENTITY</code> transform */
	public static final MathTransform2D IDENTITY;
	static {
		MathTransform2D t = null;
		try {
			t = (MathTransform2D) FactoryFinder.getMathTransformFactory(null)
					.createAffineTransform(
							new GeneralMatrix(new AffineTransform()));
		} catch (Exception e1) {
			// should not occur
		}
		IDENTITY = t;
	}

	/**
	 * Indicates the crs that will be used if the layer does not declare a crs.
	 * This crs is wgs84 crs with the name: Policy.bind("LayerImpl.unknown")
	 * (unkown in english)
	 */
	public static final CoordinateReferenceSystem UNKNOWN_CRS = new DefaultGeographicCRS(
			Policy.bind("LayerImpl.unknown"), //$NON-NLS-1$
			org.geotools.referencing.datum.DefaultGeodeticDatum.WGS84,
			org.geotools.referencing.cs.DefaultEllipsoidalCS.GEODETIC_2D);;

	/**
	 * The default value of the '{@link #getFilter() <em>Filter</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getFilter()
	 * @generated NOT
	 * @ordered
	 */
	protected static final Filter FILTER_EDEFAULT = Filter.ALL;

	/**
	 * The cached value of the '{@link #getFilter() <em>Filter</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getFilter()
	 * @generated
	 * @ordered
	 */
	protected Filter filter = FILTER_EDEFAULT;

	/**
	 * The cached value of the '{@link #getStyleBlackboard() <em>Style Blackboard</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStyleBlackboard()
	 * @generated NOT
	 * @ordered
	 */
	protected StyleBlackboard styleBlackboard = ProjectFactory.eINSTANCE
			.createStyleBlackboard();

	/**
	 * The default value of the '{@link #getZorder() <em>Zorder</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getZorder()
	 * @generated
	 * @ordered
	 */
	protected static final int ZORDER_EDEFAULT = 0;

	/**
	 * The default value of the '{@link #getStatus() <em>Status</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getStatus()
	 * @generated
	 * @ordered
	 */
	protected static final int STATUS_EDEFAULT = 0;

	/**
	 * The following adapter registers itself with a contextmodel when one is
	 * assigned it also deregisters itself when reassigned.
	 * <p>
	 * As for functionality the adapter listens for zorder changes and notifies
	 * its listeners when a change occurs
	 * </p>
	 */
	Adapter contextModelAdapter = new AdapterImpl() {
		/**
		 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
		 */
		@SuppressWarnings("unchecked")//$NON-NLS-1$
		public void notifyChanged(Notification msg) {
			// register itself with container objects
			switch (msg.getEventType()) {
			case Notification.SET: {
				if (msg.getFeatureID(Layer.class) == ProjectPackage.LAYER__CONTEXT_MODEL) {
					if (msg.getOldValue() != null)
						((ContextModel) msg.getOldValue()).eAdapters().remove(
								this);
					if (msg.getNewValue() != null)
						((ContextModel) msg.getNewValue()).eAdapters()
								.add(this);
				}
				return;
			}
			case Notification.MOVE: {
				if (msg.getFeatureID(Layer.class) == ProjectPackage.LAYER__CONTEXT_MODEL)
					if (LayerImpl.this.eNotificationRequired())
						zorderNotify(((Integer) msg.getOldValue()).intValue(),
								((Layer) msg.getNewValue()).getZorder());
				return;
			}
			}// switch

		}
	};

	/**
	 * Listeners to this layer.
	 * <p>
	 * Note this will need to be hooked into the usual EMF adapater mechasim.
	 * </p>
	 */
	ListenerList listeners;

	FeatureListener featureListener = new FeatureListener() {

		public void changed(FeatureEvent featureEvent) {
			if (featureEvent.getBounds() != null
					&& !featureEvent.getBounds().isNull()) {
				getFeatureChanges().add(featureEvent);
			} else {
				if (getFeatureChanges().size() != 0)
					getFeatureChanges().clear();
			}
			//			try {
			//				RenderManager manager = getMapInternal()
			//						.getRenderManagerInternal();
			//				if (manager != null)
			//					manager.refresh(LayerImpl.this, featureEvent.getBounds());
			//			} catch (Exception e) {
			//				// XXX this is damage control. Layer needs to be disposed when
			//				// maps closes.
			//			}

		}
	};

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	protected LayerImpl() {
		super();
		eAdapters().add(contextModelAdapter);
		CatalogPlugin.addListener(this);
	}

	/*
	 * @see net.refractions.udig.project.Layer#addListener(net.refractions.udig.project.LayerListener)
	 */
	public synchronized void addListener(final ILayerListener listener) {
		if (listeners == null) {
			listeners = new ListenerList();
		}
		listeners.add(listener);
	}

	/*
	 * @see net.refractions.udig.project.Layer#removeListener(net.refractions.udig.project.LayerListener)
	 */
	public synchronized void removeListener(final ILayerListener listener) {
		if (listeners == null)
			return;
		listeners.remove(listener);
	}

	protected void fireLayerChange(LayerEvent event) {
		if (listeners == null || listeners.size() == 0) {
			return; // nobody is listenting
		}
		for (Object obj : listeners.getListeners()) {
			ILayerListener listener = (ILayerListener) obj;
			try {
				listener.refresh(event);
			} catch (Throwable t) {
				// FIXME: log refresh error
			}
		}
	}

	protected void zorderNotify(int old, int current) {
		ENotificationImpl notification = new ENotificationImpl(LayerImpl.this,
				Notification.SET, ProjectPackage.LAYER__ZORDER, old, current,
				old == current);
		LayerImpl.this.eNotify(notification);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getLayer();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ContextModel getContextModel() {
		if (eContainerFeatureID != ProjectPackage.LAYER__CONTEXT_MODEL)
			return null;
		return (ContextModel) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setContextModel(ContextModel newContextModel) {
		if (newContextModel != eContainer
				|| (eContainerFeatureID != ProjectPackage.LAYER__CONTEXT_MODEL && newContextModel != null)) {
			if (EcoreUtil.isAncestor(this, (EObject) newContextModel))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContextModel != null)
				msgs = ((InternalEObject) newContextModel).eInverseAdd(this,
						ProjectPackage.CONTEXT_MODEL__LAYERS,
						ContextModel.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newContextModel,
					ProjectPackage.LAYER__CONTEXT_MODEL, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__CONTEXT_MODEL, newContextModel,
					newContextModel));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public int getZorder() {
		if (getContextModel() == null)
			return 0;
		return getContextModel().getLayers().indexOf(this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public void setZorder(int newZorder) {
		if (getContextModel() == null || getContextModel().getLayers() == null) {
			return;
		}

		if (newZorder >= getContextModel().getLayers().size())
			((EList) getContextModel().getLayers()).move(getContextModel()
					.getLayers().size() - 1, getContextModel().getLayers()
					.indexOf(this));
		else
			((EList) getContextModel().getLayers()).move(newZorder,
					getContextModel().getLayers().indexOf(this));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public URL getID() {
		return iD;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setID(URL newID) {
		URL oldID = iD;
		iD = newID;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__ID, oldID, iD));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isVisible() {
		return visible;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setVisible(boolean newVisible) {
		boolean oldVisible = visible;
		visible = newVisible;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__VISIBLE, oldVisible, visible));
	}

	/**
	 * <!-- begin-user-doc --> Used to find the assocaited service in the catalog. <p> On the off chance *no* services exist an empty list is returned. All this means is that the service is down, or the user has not connected to it yet (perhaps they are waiting on security permissions. </p> <p> When the real service comes along we will find out based on catalog events. </p> <!-- end-user-doc -->
	 * @uml.property   name="geoResources"
	 * @generated  NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<IGeoResource> getGeoResources() {
		synchronized (this) {
			if (geoResources == NULL)
				return geoResources;

			if (geoResources == null) {
				geoResources = new EDataTypeUniqueEList(IGeoResource.class,
						this, ProjectPackage.LAYER__GEO_RESOURCES);
			}
			if (geoResources.size() == 0) {
				if (!catalogRef.isLoaded()) {
					catalogRef.load();
				}
				ICatalog connections = CatalogPlugin.getDefault()
						.getLocalCatalog();
				//do non blocking search for services first
				URL id = getID();
				if (id == null )
					return NULL;
				URL serviceId;
				try {
					serviceId = new URL(id.toString().substring(0, id.toString().indexOf("#"))); //$NON-NLS-1$
					List<IService> services = connections
							.findService(serviceId);
					for (IService service : services) {
						if (service.getStatus() == IResolve.Status.BROKEN)
							continue;

						//JONES dialog monitor or something?
						IProgressMonitor monitor = new NullProgressMonitor();
						List<? extends IGeoResource> members = service
								.members(monitor);
						for (IGeoResource resource : members) {
							if (resource.getIdentifier().getRef().equals(
									id.getRef()))
								geoResources.add(new LayerResource(this,
										resource));
						}
					}
				} catch (Exception e) {
					ProjectPlugin.log("Error getting layer resources", e); //$NON-NLS-1$
				}
			}
			if (geoResources.size() == 0) {
				setStatus(ERROR);
				setStatusMessage(Policy.bind("LayerImpl.0")); //$NON-NLS-1$
				return NULL;
			}

		}
		return geoResources;
	}

	/**
	 * will be returned by getGeoResources and getGeoResource in the real
	 * connection is broken.
	 */
	static public final EList NULL;
	static {
		NULL = new BasicEList();
		NULL.add(new NullGeoResource());
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#getGeoResources(int)
	 */
	public <T> IGeoResource getGeoResource(Class<T> clazz) {
		List<IGeoResource> resources = getGeoResources();
		for (IGeoResource resource : resources) {
			if (resource.canResolve(clazz))
				return resource;
		}

		return null;
	}

	/**
	 <<<<<<< .working
	 * Resource associated with this layer. <p> TODO Switch the model over to this idea, resources can return the resources linked to this one. </p>
	 * @return   first resource from resources();
	 * @uml.property   name="geoResource"
	 =======
	 * Resource associated with this layer.
	 * <p>
	 * TODO Switch the model over to this idea, resources can return the resources linked to this
	 * one.
	 * </p>
	 * 
	 * @return first resource from resources();
	 >>>>>>> .merge-right.r15740
	 */
	public IGeoResource getGeoResource() {
		if (geoResource == null) {
			synchronized (this) {
				if (geoResource == null) {
					if (getGeoResources() != NULL)
						geoResource = getGeoResources().get(0);
					else {
						return (IGeoResource) NULL.get(0);
					}
				}
			}
		}
		return geoResource;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @uml.property   name="geoResource"
	 * @generated  NOT
	 */
	public void setGeoResource(IGeoResource newPreferredGeoResource) {
		IGeoResource oldPreferredGeoResource = geoResource;
		geoResource = newPreferredGeoResource;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__GEO_RESOURCE,
					oldPreferredGeoResource, geoResource));
	}

	public <E> E getResource(Class<E> resourceType, IProgressMonitor monitor)
			throws IOException {
		for (IGeoResource georesource : getGeoResources()) {
			if (georesource.canResolve(resourceType)) {
				return georesource.resolve(resourceType, monitor);
			}
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @uml.property   name="catalogRef"
	 * @generated  NOT
	 */
	public CatalogRef getCatalogRef() {
		if (catalogRef.getLayer() != this)
			catalogRef.setLayer(this);
		return catalogRef;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setCatalogRef(CatalogRef newCatalogRef) {
		CatalogRef oldCatalogRef = catalogRef;
		catalogRef = newCatalogRef;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__CATALOG_REF, oldCatalogRef,
					catalogRef));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public StyleBlackboard getStyleBlackboard() {
		return styleBlackboard;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStyleBlackboard(
			StyleBlackboard newStyleBlackboard, NotificationChain msgs) {
		StyleBlackboard oldStyleBlackboard = styleBlackboard;
		styleBlackboard = newStyleBlackboard;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET, ProjectPackage.LAYER__STYLE_BLACKBOARD,
					oldStyleBlackboard, newStyleBlackboard);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @uml.property   name="styleBlackboard"
	 * @generated  NOT
	 */
	public void setStyleBlackboard(StyleBlackboard newStyleBlackboard) {
		if (newStyleBlackboard != styleBlackboard) {
			NotificationChain msgs = null;
			if (styleBlackboard != null)
				msgs = ((InternalEObject) styleBlackboard).eInverseRemove(this,
						EOPPOSITE_FEATURE_BASE
								- ProjectPackage.LAYER__STYLE_BLACKBOARD, null,
						msgs);
			if (newStyleBlackboard != null)
				msgs = ((InternalEObject) newStyleBlackboard).eInverseAdd(this,
						EOPPOSITE_FEATURE_BASE
								- ProjectPackage.LAYER__STYLE_BLACKBOARD, null,
						msgs);
			msgs = basicSetStyleBlackboard(newStyleBlackboard, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__STYLE_BLACKBOARD, newStyleBlackboard,
					newStyleBlackboard));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Filter getFilter() {
		return filter;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setFilter(Filter newFilter) {
		Filter oldFilter = filter;
		filter = newFilter;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__FILTER, oldFilter, filter));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public int getStatus() {
		return status;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setStatus(int newStatus) {
		int oldStatus = status;
		status = newStatus;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__STATUS, oldStatus, status));
	}

	/**
	 * Locate the first IGeoResource that canResolve the provided resource type.
	 * <p>
	 * Example implementation:
	 * 
	 * <pre><code>
	 * for (IGeoResource resource : getGeoResources()) {
	 * 	if (resource.canResolve(FeatureSource.class)) {
	 * 		return resource;
	 * 	}
	 * }
	 * return null;
	 * </code></pre>
	 * 
	 * </p>
	 * 
	 * @param resourceType
	 * @return true if a IGeoResource exists that canResolve to resourceType.
	 * @model
	 */
	public IGeoResource findGeoResource(Class resourceType) {
		for (IGeoResource resource : getGeoResources()) {
			if (resource.canResolve(FeatureSource.class)) {
				return resource;
			}
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public <T> boolean isType(Class<T> resourceType) {
		for (IGeoResource resource : getGeoResources()) {
			if (resource.canResolve(resourceType))
				return true;
		}
		return false;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ImageDescriptor getGlyph() {
		return glyph;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setGlyph(ImageDescriptor newGlyph) {
		ImageDescriptor oldGlyph = glyph;
		glyph = newGlyph;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__GLYPH, oldGlyph, glyph));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSelectable() {
		return selectable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setSelectable(boolean newSelectable) {
		boolean oldSelectable = selectable;
		selectable = newSelectable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__SELECTABLE, oldSelectable, selectable));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.LAYER__CONTEXT_MODEL:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd,
						ProjectPackage.LAYER__CONTEXT_MODEL, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.LAYER__CONTEXT_MODEL:
				return eBasicSetContainer(null,
						ProjectPackage.LAYER__CONTEXT_MODEL, msgs);
			case ProjectPackage.LAYER__STYLE_BLACKBOARD:
				return basicSetStyleBlackboard(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case ProjectPackage.LAYER__CONTEXT_MODEL:
				return eContainer.eInverseRemove(this,
						ProjectPackage.CONTEXT_MODEL__LAYERS,
						ContextModel.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
				- eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER__CONTEXT_MODEL:
			return getContextModel();
		case ProjectPackage.LAYER__FILTER:
			return getFilter();
		case ProjectPackage.LAYER__STYLE_BLACKBOARD:
			return getStyleBlackboard();
		case ProjectPackage.LAYER__ZORDER:
			return new Integer(getZorder());
		case ProjectPackage.LAYER__STATUS:
			return new Integer(getStatus());
		case ProjectPackage.LAYER__SELECTABLE:
			return isSelectable() ? Boolean.TRUE : Boolean.FALSE;
		case ProjectPackage.LAYER__NAME:
			return getName();
		case ProjectPackage.LAYER__CATALOG_REF:
			return getCatalogRef();
		case ProjectPackage.LAYER__ID:
			return getID();
		case ProjectPackage.LAYER__VISIBLE:
			return isVisible() ? Boolean.TRUE : Boolean.FALSE;
		case ProjectPackage.LAYER__GEO_RESOURCE:
			return getGeoResource();
		case ProjectPackage.LAYER__GEO_RESOURCES:
			return getGeoResources();
		case ProjectPackage.LAYER__GLYPH:
			return getGlyph();
		case ProjectPackage.LAYER__CRS:
			return getCRS();
		case ProjectPackage.LAYER__PROPERTIES:
			return getProperties();
		case ProjectPackage.LAYER__COLOUR_SCHEME:
			return getColourScheme();
		case ProjectPackage.LAYER__DEFAULT_COLOR:
			return getDefaultColor();
		case ProjectPackage.LAYER__FEATURE_CHANGES:
			return getFeatureChanges();
		case ProjectPackage.LAYER__MIN_SCALE_DENOMINATOR:
			return new Double(getMinScaleDenominator());
		case ProjectPackage.LAYER__MAX_SCALE_DENOMINATOR:
			return new Double(getMaxScaleDenominator());
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER__CONTEXT_MODEL:
			setContextModel((ContextModel) newValue);
			return;
		case ProjectPackage.LAYER__FILTER:
			setFilter((Filter) newValue);
			return;
		case ProjectPackage.LAYER__STYLE_BLACKBOARD:
			setStyleBlackboard((StyleBlackboard) newValue);
			return;
		case ProjectPackage.LAYER__ZORDER:
			setZorder(((Integer) newValue).intValue());
			return;
		case ProjectPackage.LAYER__STATUS:
			setStatus(((Integer) newValue).intValue());
			return;
		case ProjectPackage.LAYER__SELECTABLE:
			setSelectable(((Boolean) newValue).booleanValue());
			return;
		case ProjectPackage.LAYER__NAME:
			setName((String) newValue);
			return;
		case ProjectPackage.LAYER__CATALOG_REF:
			setCatalogRef((CatalogRef) newValue);
			return;
		case ProjectPackage.LAYER__ID:
			setID((URL) newValue);
			return;
		case ProjectPackage.LAYER__VISIBLE:
			setVisible(((Boolean) newValue).booleanValue());
			return;
		case ProjectPackage.LAYER__GEO_RESOURCE:
			setGeoResource((IGeoResource) newValue);
			return;
		case ProjectPackage.LAYER__GLYPH:
			setGlyph((ImageDescriptor) newValue);
			return;
		case ProjectPackage.LAYER__CRS:
			setCRS((CoordinateReferenceSystem) newValue);
			return;
		case ProjectPackage.LAYER__COLOUR_SCHEME:
			setColourScheme((ColourScheme) newValue);
			return;
		case ProjectPackage.LAYER__DEFAULT_COLOR:
			setDefaultColor((String) newValue);
			return;
		case ProjectPackage.LAYER__FEATURE_CHANGES:
			getFeatureChanges().clear();
			getFeatureChanges().addAll((Collection) newValue);
			return;
		case ProjectPackage.LAYER__MIN_SCALE_DENOMINATOR:
			setMinScaleDenominator(((Double) newValue).doubleValue());
			return;
		case ProjectPackage.LAYER__MAX_SCALE_DENOMINATOR:
			setMaxScaleDenominator(((Double) newValue).doubleValue());
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER__CONTEXT_MODEL:
			setContextModel((ContextModel) null);
			return;
		case ProjectPackage.LAYER__FILTER:
			setFilter(FILTER_EDEFAULT);
			return;
		case ProjectPackage.LAYER__STYLE_BLACKBOARD:
			setStyleBlackboard((StyleBlackboard) null);
			return;
		case ProjectPackage.LAYER__ZORDER:
			setZorder(ZORDER_EDEFAULT);
			return;
		case ProjectPackage.LAYER__STATUS:
			setStatus(STATUS_EDEFAULT);
			return;
		case ProjectPackage.LAYER__SELECTABLE:
			setSelectable(SELECTABLE_EDEFAULT);
			return;
		case ProjectPackage.LAYER__NAME:
			setName(NAME_EDEFAULT);
			return;
		case ProjectPackage.LAYER__CATALOG_REF:
			setCatalogRef(CATALOG_REF_EDEFAULT);
			return;
		case ProjectPackage.LAYER__ID:
			setID(ID_EDEFAULT);
			return;
		case ProjectPackage.LAYER__VISIBLE:
			setVisible(VISIBLE_EDEFAULT);
			return;
		case ProjectPackage.LAYER__GEO_RESOURCE:
			setGeoResource(GEO_RESOURCE_EDEFAULT);
			return;
		case ProjectPackage.LAYER__GLYPH:
			setGlyph(GLYPH_EDEFAULT);
			return;
		case ProjectPackage.LAYER__CRS:
			setCRS(CRS_EDEFAULT);
			return;
		case ProjectPackage.LAYER__COLOUR_SCHEME:
			setColourScheme(COLOUR_SCHEME_EDEFAULT);
			return;
		case ProjectPackage.LAYER__DEFAULT_COLOR:
			setDefaultColor(DEFAULT_COLOR_EDEFAULT);
			return;
		case ProjectPackage.LAYER__FEATURE_CHANGES:
			getFeatureChanges().clear();
			return;
		case ProjectPackage.LAYER__MIN_SCALE_DENOMINATOR:
			setMinScaleDenominator(MIN_SCALE_DENOMINATOR_EDEFAULT);
			return;
		case ProjectPackage.LAYER__MAX_SCALE_DENOMINATOR:
			setMaxScaleDenominator(MAX_SCALE_DENOMINATOR_EDEFAULT);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.LAYER__CONTEXT_MODEL:
			return getContextModel() != null;
		case ProjectPackage.LAYER__FILTER:
			return FILTER_EDEFAULT == null ? filter != null : !FILTER_EDEFAULT
					.equals(filter);
		case ProjectPackage.LAYER__STYLE_BLACKBOARD:
			return styleBlackboard != null;
		case ProjectPackage.LAYER__ZORDER:
			return getZorder() != ZORDER_EDEFAULT;
		case ProjectPackage.LAYER__STATUS:
			return status != STATUS_EDEFAULT;
		case ProjectPackage.LAYER__SELECTABLE:
			return selectable != SELECTABLE_EDEFAULT;
		case ProjectPackage.LAYER__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT
					.equals(name);
		case ProjectPackage.LAYER__CATALOG_REF:
			return CATALOG_REF_EDEFAULT == null ? catalogRef != null
					: !CATALOG_REF_EDEFAULT.equals(catalogRef);
		case ProjectPackage.LAYER__ID:
			return ID_EDEFAULT == null ? iD != null : !ID_EDEFAULT.equals(iD);
		case ProjectPackage.LAYER__VISIBLE:
			return visible != VISIBLE_EDEFAULT;
		case ProjectPackage.LAYER__GEO_RESOURCE:
			return GEO_RESOURCE_EDEFAULT == null ? geoResource != null
					: !GEO_RESOURCE_EDEFAULT.equals(geoResource);
		case ProjectPackage.LAYER__GEO_RESOURCES:
			return geoResources != null && !geoResources.isEmpty();
		case ProjectPackage.LAYER__GLYPH:
			return GLYPH_EDEFAULT == null ? glyph != null : !GLYPH_EDEFAULT
					.equals(glyph);
		case ProjectPackage.LAYER__CRS:
			return CRS_EDEFAULT == null ? cRS != null : !CRS_EDEFAULT
					.equals(cRS);
		case ProjectPackage.LAYER__PROPERTIES:
			return properties != null;
		case ProjectPackage.LAYER__COLOUR_SCHEME:
			return COLOUR_SCHEME_EDEFAULT == null ? colourScheme != null
					: !COLOUR_SCHEME_EDEFAULT.equals(colourScheme);
		case ProjectPackage.LAYER__DEFAULT_COLOR:
			return DEFAULT_COLOR_EDEFAULT == null ? defaultColor != null
					: !DEFAULT_COLOR_EDEFAULT.equals(defaultColor);
		case ProjectPackage.LAYER__FEATURE_CHANGES:
			return featureChanges != null && !featureChanges.isEmpty();
		case ProjectPackage.LAYER__MIN_SCALE_DENOMINATOR:
			return minScaleDenominator != MIN_SCALE_DENOMINATOR_EDEFAULT;
		case ProjectPackage.LAYER__MAX_SCALE_DENOMINATOR:
			return maxScaleDenominator != MAX_SCALE_DENOMINATOR_EDEFAULT;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer();
		result.append(" (name: "); //$NON-NLS-1$
		result.append(name);
		result.append(')');
		return result.toString();
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#getQuery(net.refractions.udig.project.Layer,
	 *      boolean)
	 * @generated NOT
	 */
	public Query getQuery(boolean selection) {
		try {
			if (selection)
				return new DefaultQuery(getSchema().getTypeName(), getFilter());
			else
				return Query.ALL;
		} catch (Exception e) {
			if (selection) {
				DefaultQuery q = new DefaultQuery();
				q.setFilter(Filter.ALL);
				return q;
			} else
				return Query.ALL;
		}
	}

	private int status;

	/**
	 * The default value of the '{@link #isSelectable() <em>Selectable</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isSelectable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean SELECTABLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isSelectable() <em>Selectable</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isSelectable()
	 * @generated
	 * @ordered
	 */
	protected boolean selectable = SELECTABLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getCatalogRef() <em>Catalog Ref</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCatalogRef()
	 * @generated
	 * @ordered
	 */
	protected static final CatalogRef CATALOG_REF_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCatalogRef() <em>Catalog Ref</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCatalogRef()
	 * @generated NOT
	 * @ordered
	 */
	protected CatalogRef catalogRef = new CatalogRef(this);

	/**
	 * The default value of the '{@link #getID() <em>ID</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getID()
	 * @generated
	 * @ordered
	 */
	protected static final URL ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getID() <em>ID</em>}' attribute. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getID()
	 * @generated
	 * @ordered
	 */
	protected URL iD = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #isVisible() <em>Visible</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isVisible()
	 * @generated NOT
	 * @ordered
	 */
	protected static final boolean VISIBLE_EDEFAULT = true;

	/**
	 * The cached value of the '{@link #isVisible() <em>Visible</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #isVisible()
	 * @generated
	 * @ordered
	 */
	protected boolean visible = VISIBLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getGeoResource() <em>Geo Resource</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGeoResource()
	 * @generated
	 * @ordered
	 */
	protected static final IGeoResource GEO_RESOURCE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getGeoResource() <em>Geo Resource</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGeoResource()
	 * @generated
	 * @ordered
	 */
	protected IGeoResource geoResource = GEO_RESOURCE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getGeoResources() <em>Geo Resources</em>}' attribute list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGeoResources()
	 * @generated
	 * @ordered
	 */
	protected EList geoResources = null;

	/**
	 * The default value of the '{@link #getGlyph() <em>Glyph</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGlyph()
	 * @generated
	 * @ordered
	 */
	protected static final ImageDescriptor GLYPH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getGlyph() <em>Glyph</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getGlyph()
	 * @generated
	 * @ordered
	 */
	protected ImageDescriptor glyph = GLYPH_EDEFAULT;

	/**
	 * The default value of the '{@link #getCRS() <em>CRS</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCRS()
	 * @generated
	 * @ordered
	 */
	protected static final CoordinateReferenceSystem CRS_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCRS() <em>CRS</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getCRS()
	 * @generated
	 * @ordered
	 */
	protected CoordinateReferenceSystem cRS = CRS_EDEFAULT;

	/**
	 * The cached value of the '{@link #getProperties() <em>Properties</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getProperties()
	 * @generated NOT
	 * @ordered
	 */
	protected IBlackboard properties = new SimpleBlackboard();

	/**
	 * The default value of the '{@link #getColourScheme() <em>Colour Scheme</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getColourScheme()
	 * @generated
	 * @ordered
	 */
	protected static final ColourScheme COLOUR_SCHEME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getColourScheme() <em>Colour Scheme</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getColourScheme()
	 * @generated
	 * @ordered
	 */
	protected ColourScheme colourScheme = COLOUR_SCHEME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDefaultColor() <em>Default Color</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDefaultColor()
	 * @generated
	 * @ordered
	 */
	protected static final String DEFAULT_COLOR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDefaultColor() <em>Default Color</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getDefaultColor()
	 * @generated
	 * @ordered
	 */
	protected String defaultColor = DEFAULT_COLOR_EDEFAULT;

	/**
	 * The cached value of the '{@link #getFeatureChanges() <em>Feature Changes</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFeatureChanges()
	 * @generated
	 * @ordered
	 */
	protected EList featureChanges = null;

	/**
	 * The default value of the '{@link #getMinScaleDenominator() <em>Min Scale Denominator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinScaleDenominator()
	 * @generated
	 * @ordered
	 */
	protected static final double MIN_SCALE_DENOMINATOR_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getMinScaleDenominator() <em>Min Scale Denominator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinScaleDenominator()
	 * @generated
	 * @ordered
	 */
	protected double minScaleDenominator = MIN_SCALE_DENOMINATOR_EDEFAULT;

	/**
	 * The default value of the '{@link #getMaxScaleDenominator() <em>Max Scale Denominator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxScaleDenominator()
	 * @generated
	 * @ordered
	 */
	protected static final double MAX_SCALE_DENOMINATOR_EDEFAULT = 0.0;

	/**
	 * The cached value of the '{@link #getMaxScaleDenominator() <em>Max Scale Denominator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMaxScaleDenominator()
	 * @generated
	 * @ordered
	 */
	protected double maxScaleDenominator = MAX_SCALE_DENOMINATOR_EDEFAULT;

	private String statusMessage = Policy.bind("LayerImpl.status"); //$NON-NLS-1$

	/**
	 * @see net.refractions.udig.project.internal.Layer#getSchema()
	 */
	public FeatureType getSchema() {
		FeatureSource data;
		try {
			data = getResource(FeatureSource.class, null);
			if (data != null) {
				return data.getSchema();
			}
		} catch (IOException e) {
			ProjectPlugin.log(null, e);
		}
		// XXX: rgould how do I process a getWMS().createDescribeLayerRequest()?

		// URL wfsURL = null;
		//        
		// try {
		// DescribeLayerRequest request = null;
		// request = getWMS().createDescribeLayerRequest();
		// request.setLayers(getName());
		// DescribeLayerResponse response = (DescribeLayerResponse)
		// getWMS().issueRequest(request);
		// wfsURL = response.getLayerDescs()[0].getWfs();
		// } catch (SAXException e1) {
		// // TODO Catch e1
		// } catch (UnsupportedOperationException e) {
		// // TODO Catch e
		// } catch (IOException e) {
		// // TODO Catch e
		// }

		// WFS URL now possibly has a URL

		return null;
	}

	/**
	 * @see java.lang.Comparable#compareTo(java.lang.Object)
	 */
	public int compareTo(ILayer arg0) {
		if (arg0 == null)
			return 1;

		int i1 = getZorder();
		int i2 = ((Layer) arg0).getZorder();

		if (i1 == i2)
			return 0;
		return i1 < i2 ? 1 : -1;
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#isApplicable(java.lang.String)
	 */
	public boolean isApplicable(String toolsetID) {
		if (getProperties().get(toolsetID) == null)
			return true;
		return (Boolean) getProperties().get(toolsetID);
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#setApplicable(java.lang.String,
	 *      boolean)
	 */
	public void setApplicable(String toolsetID, boolean applicable) {
		getProperties().put(toolsetID, applicable);
		// XXX just to send an event needs to change.
		setSelectable(isSelectable());
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @uml.property   name="cRS"
	 * @generated  NOT
	 */
	public CoordinateReferenceSystem getCRS() {
		return getCRS(null);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setCRS(CoordinateReferenceSystem newCRS) {
		CoordinateReferenceSystem oldCRS = cRS;
		cRS = newCRS;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__CRS, oldCRS, cRS));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public IBlackboard getProperties() {
		return properties;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public ColourScheme getColourScheme() {
		return colourScheme;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setColourScheme(ColourScheme newColourScheme) {
		ColourScheme oldColourScheme = colourScheme;
		colourScheme = newColourScheme;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__COLOUR_SCHEME, oldColourScheme,
					colourScheme));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public String getDefaultColor() {
		return defaultColor;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefaultColor(String newDefaultColor) {
		String oldDefaultColor = defaultColor;
		defaultColor = newDefaultColor;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__DEFAULT_COLOR, oldDefaultColor,
					defaultColor));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	public List<FeatureEvent> getFeatureChanges() {
		if (featureChanges == null) {
			featureChanges = new EDataTypeUniqueEList(FeatureEvent.class, this,
					ProjectPackage.LAYER__FEATURE_CHANGES);
		}
		return featureChanges;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getMinScaleDenominator() {
		return minScaleDenominator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinScaleDenominator(double newMinScaleDenominator) {
		double oldMinScaleDenominator = minScaleDenominator;
		minScaleDenominator = newMinScaleDenominator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__MIN_SCALE_DENOMINATOR,
					oldMinScaleDenominator, minScaleDenominator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public double getMaxScaleDenominator() {
		return maxScaleDenominator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMaxScaleDenominator(double newMaxScaleDenominator) {
		double oldMaxScaleDenominator = maxScaleDenominator;
		maxScaleDenominator = newMaxScaleDenominator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__MAX_SCALE_DENOMINATOR,
					oldMaxScaleDenominator, maxScaleDenominator));
	}

	/**
	 * @see java.lang.Object#clone()
	 */
	public Layer clone() {
		Layer layer = new LayerImpl();
		layer.setFilter(getFilter());
		layer.setGlyph(layer.getGlyph());
		layer.setID(getID());
		layer.setName(getName());
		layer
				.setStyleBlackboard((StyleBlackboard) getStyleBlackboard()
						.clone());

		return layer;
	}

	/**
	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
	 */
	public Object getAdapter(final Class adapter) {
		if (IGeoResource.class.isAssignableFrom(adapter))
			return getGeoResource();

		return null;
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#getCRS()
	 */
	public CoordinateReferenceSystem getCRS(IProgressMonitor monitor) {

		if (cRS != null)
			return cRS;
		try {
			CoordinateReferenceSystem crs = getGeoResource().getInfo(monitor)
					.getCRS();
			if (crs != null)
				return crs;
		} catch (Exception e) {
			ProjectPlugin.log(null, e);
		}

		List<IGeoResource> list = getGeoResources();
		for (IGeoResource resource : list) {
			try {
				if (resource.getInfo(monitor).getCRS() != null)
					return resource.getInfo(monitor).getCRS();
			} catch (Exception e) {
				ProjectPlugin.log(null, e);
			}
		}

		return getMapInternal().getViewportModelInternal().getCRS();
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#refresh()
	 */
	public void refresh(Envelope bounds) {
		if (!isVisible())
			return;
		if (getContextModel() == null
				|| getContextModel().getMap() == null
				|| getContextModel().getMap().getRenderManager() == null
				|| getContextModel().getMap().getRenderManager()
						.getMapDisplay() == null
				|| getContextModel().getMap().getRenderManagerInternal()
						.getRenderExecutor() == null)
			return;

		getContextModel().getMap().getRenderManager().refresh(this, bounds);

	}

	private MathTransform mapToLayerTransform;

	private MathTransform layerToMapTransform;

	private CoordinateReferenceSystem lastViewportCRS;

	private CoordinateReferenceSystem lastLayerCRS;

	/**
	 * @see net.refractions.udig.project.internal.Layer#layerToMapTransform()
	 */
	public MathTransform layerToMapTransform() {
		if (layerToMapTransform == null
				|| lastViewportCRS != getMap().getViewportModel().getCRS()
				|| lastLayerCRS != getCRS()) {
			lastViewportCRS = getMap().getViewportModel().getCRS();
			lastLayerCRS = getCRS();
			try {
				layerToMapTransform = CRS.transform(lastLayerCRS,
						lastViewportCRS, true);
			} catch (Exception e) {
				layerToMapTransform = IDENTITY;
			}
		}
		return layerToMapTransform;
	}

	/**
	 * @see net.refractions.udig.project.ILayer#mapToLayerTransform()
	 */
	public MathTransform mapToLayerTransform() {
		if (mapToLayerTransform == null
				|| lastViewportCRS != getMap().getViewportModel().getCRS()
				|| lastLayerCRS != getCRS()) {
			lastViewportCRS = getMap().getViewportModel().getCRS();
			lastLayerCRS = getCRS();
			try {
				mapToLayerTransform = CRS.transform(lastViewportCRS,
						lastLayerCRS, true);
			} catch (Exception e) {
				mapToLayerTransform = IDENTITY;
			}
		}
		return mapToLayerTransform;
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#getBounds(org.eclipse.core.runtime.IProgressMonitor,
	 *      org.opengis.referencing.crs.CoordinateReferenceSystem)
	 */
	public JTS.ReferencedEnvelope getBounds(IProgressMonitor monitor,
			CoordinateReferenceSystem crs) {
		for (IGeoResource resource : getGeoResources()) {
			try {
				IGeoResourceInfo info = resource.getInfo(monitor);
				JTS.ReferencedEnvelope bounds = (ReferencedEnvelope) info
						.getBounds();
				if (bounds == null)
					return new ReferencedEnvelope(new Envelope(-180, 180, -90,
							90), UNKNOWN_CRS);
				if (bounds.getCRS() == null && cRS == null) {
					return bounds;
				}
				if (bounds.getCRS() == null || bounds.getCRS().equals(crs)) {
					return bounds;
				}
				try {
					MathTransform transform = CRS.transform(bounds.getCRS(),
							crs, true);
					return new JTS.ReferencedEnvelope(JTS.transform(bounds,
							transform), crs);
				} catch (Exception fe) {
					return bounds;
				}
			} catch (IOException e) {
				// continue to next
			}
		}
		return new JTS.ReferencedEnvelope(new Envelope(), null);
	}

	/**
	 * Creates A geometry filter for the given layer.
	 * 
	 * @param boundingBox
	 *            in the same crs as the viewport model.
	 * @return a Geometry filter in the correct CRS or null if an exception
	 *         occurs.
	 */
	public Filter createBBoxFilter(Envelope boundingBox,
			IProgressMonitor monitor) {
		FilterFactory factory = FilterFactory.createFilterFactory();
		GeometryFilter bboxFilter = null;
		if (!isType(FeatureSource.class))
			return Filter.ALL;
		try {

			Envelope bbox;
			try {
				MathTransform transform = mapToLayerTransform();
				bbox = JTS.transform(boundingBox, transform);
			} catch (Exception e) {
				bbox = boundingBox;
			}
			BBoxExpression bb = factory.createBBoxExpression(bbox);
			bboxFilter = factory
					.createGeometryFilter(FilterType.GEOMETRY_INTERSECTS);
			bboxFilter.addRightGeometry(bb);

			String geom = getSchema().getDefaultGeometry().getName();

			bboxFilter.addLeftGeometry(factory.createAttributeExpression(
					getSchema(), geom));
		} catch (Exception e) {
			ProjectPlugin.getPlugin().log(e);
		}
		return bboxFilter;
	}

	/**
	 * @see net.refractions.udig.project.internal.Layer#getMap()
	 */
	public net.refractions.udig.project.internal.Map getMapInternal() {
		return getContextModel().getMap();
	}

	/**
	 * @see net.refractions.udig.project.ILayer#getMap()
	 */
	public IMap getMap() {
		return getMapInternal();
	}

	/**
	 * @see net.refractions.udig.core.IBlockingAdaptable#getAdapter(java.lang.Class,
	 *      org.eclipse.core.runtime.IProgressMonitor)
	 */
	public <T> T getAdapter(final Class<T> adapter, IProgressMonitor monitor) {
		if (isType(adapter)) {
			final List<T> list = new ArrayList<T>();
			Job job = new Job("resolve adapter") { //$NON-NLS-1$

				protected IStatus run(IProgressMonitor monitor) {
					try {
						list.add(getResource(adapter, monitor));
					} catch (IOException e) {
						ProjectPlugin.log(null, e);
					}

					return Status.OK_STATUS;
				}
			};
			job.setSystem(true);
			job.schedule();
			try {
				job.join();
			} catch (InterruptedException e) {
				ProjectPlugin.log(null, e);
			}
			if (list.size() > 0)
				return list.get(0);
		}
		return null;
	}

	/**
	 * @see net.refractions.udig.core.IBlockingAdaptable#canAdaptTo(java.lang.Class)
	 */
	public <T> boolean canAdaptTo(Class<T> adapter) {
		return isType(adapter);
	}

	/**
	 * @see net.refractions.udig.project.internal.LayerDecorator#setStatusMessage(java.lang.String)
	 * @uml.property   name="statusMessage"
	 */
	public void setStatusMessage(String message) {
		this.statusMessage = message;
	}

	/**
	 * @see net.refractions.udig.project.internal.LayerDecorator#getStatusMessage()
	 * @uml.property   name="statusMessage"
	 */
	public String getStatusMessage() {
		return statusMessage;
	}

	@Override
	public EList eAdapters() {
		return super.eAdapters();
	}

	void resetConnection() {
		this.geoResources = null;
		if (eNotificationRequired()) {
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__GEO_RESOURCES, null, null));
			eNotify(new ENotificationImpl(this, Notification.SET,
					ProjectPackage.LAYER__GEO_RESOURCE, null, null));
		}
		ProjectPlugin.trace("Smack " + getID(), null); //$NON-NLS-1$
		if (status != DONE)
			refresh(null);
	}

	public void changed(IResolveChangeEvent event) {
		IResolveDelta delta = event.getDelta();
		IResolve hit = event.getResolve();
		if (delta.getKind() == IResolveDelta.Kind.NO_CHANGE && hit != null) {
			URL effected = hit.getIdentifier();
			if (getID() == effected) {
				resetConnection();
			}
		}
		// should search throug the whole delta?
		delta = SearchIDDeltaVisitor.search(getID(), event);
		if (delta != null) {
			ProjectPlugin.trace("Reset resource" + getID(), null); //$NON-NLS-1$
			resetConnection();
		}
	}

} // LayerImpl
