/**
 * <copyright></copyright> $Id$
 */
package net.refractions.udig.project.internal.impl;

import java.io.IOException;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.URL;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import net.refractions.udig.core.internal.ExtensionPointProcessor;
import net.refractions.udig.core.internal.ExtensionPointUtil;
import net.refractions.udig.project.StyleContent;
import net.refractions.udig.project.internal.ProjectFactory;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.StyleBlackboard;
import net.refractions.udig.project.internal.StyleEntry;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.ui.WorkbenchException;
import org.eclipse.ui.XMLMemento;

/**
 * TODO Purpose of net.refractions.udig.project.internal.impl <p> </p>
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class StyleBlackboardImpl extends EObjectImpl implements StyleBlackboard {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getContent() <em>Content</em>}' containment reference list.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @see #getContent()
	 * @generated
	 * @ordered
	 */
	protected EList content = null;

	/**
	 * Map of style id to StyleContent
	 * @uml.property   name="id2content"
	 * @uml.associationEnd   qualifier="key:java.lang.Object net.refractions.udig.project.StyleContent"
	 * @generated  NOT
	 */
	protected HashMap<String, StyleContent> id2content = new HashMap<String, StyleContent>();

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected StyleBlackboardImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ProjectPackage.eINSTANCE.getStyleBlackboard();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public List getContent() {
		if (content == null) {
			content = new EObjectContainmentEList(StyleEntry.class, this,
					ProjectPackage.STYLE_BLACKBOARD__CONTENT);
		}
		return content;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Object get(String styleId) {
		StyleEntry entry = null;
		for (Iterator seItr = getContent().iterator(); seItr.hasNext();) {
			StyleEntry se = (StyleEntry) seItr.next();
			if (se.getID().equals(styleId)) {
				entry = se;
				break;
			}
		}

		if (entry == null)
			return null;
		return getObject(entry);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Object lookup(Class theClass) {
		StyleEntry entry = null;
		for (Iterator seItr = getContent().iterator(); seItr.hasNext();) {
			StyleEntry se = (StyleEntry) seItr.next();
			if (se.getStyleClass() == null) {
				StyleContent styleContent = getStyleContent(se.getID());
				se.setStyleClass(styleContent.getStyleClass());
			}
			if (theClass.isAssignableFrom(se.getStyleClass())) {
				entry = se;
				break;
			}
		}

		if (entry == null)
			return null;
		return getObject(entry);
	}

	/**
	 * Gets the style object from a StyleEntry. Either from the StyleEntry cache or from the
	 * StyleContent associated with the entry.
	 * 
	 * @generated NOT
	 */
	protected Object getObject(StyleEntry styleEntry) {
		// reload style state if necessary
		if (styleEntry.getStyle() == null) {
			try {
				StyleContent styleContent = getStyleContent(styleEntry.getID());
				XMLMemento memento = XMLMemento
						.createReadRoot(new StringReader(styleEntry
								.getMemento()));
				Object style = styleContent.load(memento);
				styleEntry.setStyle(style);
			} catch (WorkbenchException e) {
				e.printStackTrace();
			}
		}

		return styleEntry.getStyle();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public boolean contains(String styleId) {
		return get(styleId) != null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void put(String styleId, Object style) {
		remove(styleId);

		StyleEntry se = ProjectFactory.eINSTANCE.createStyleEntry();
		se.setID(styleId);
		se.setStyle(style);

		content.add(se);

		StyleContent styleContent = getStyleContent(styleId);

		try {
			// save the state of the style
			XMLMemento memento = XMLMemento.createWriteRoot("styleEntry"); //$NON-NLS-1$
			styleContent.save(memento, style);

			StringWriter writer = new StringWriter();
			memento.save(writer);
			se.setMemento(writer.getBuffer().toString());

			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void put(URL url, IProgressMonitor monitor) {
		createStyleEntry(url, monitor);
	}

	/**
	 * @generated NOT
	 */
	private StyleContent getStyleContent(String styleId) {

		// look in local cache first
		StyleContent styleContent = id2content.get(styleId);
		if (styleContent == null) {
			loadStyleContent(styleId);
			styleContent = id2content.get(styleId);
		}
		return styleContent;
	}

	/**
	 * @generated NOT
	 */
	private void loadStyleContent(final String styleId) {

		ExtensionPointProcessor p = new ExtensionPointProcessor() {
			boolean found = false;

			public void process(IExtension extension,
					IConfigurationElement element) throws Exception {
				if (!found && element.getAttribute("id").equals(styleId)) { //$NON-NLS-1$
					found = true;
					id2content.put(styleId, (StyleContent) element
							.createExecutableExtension("class") //$NON-NLS-1$
							);
				}
			}
		};
		ExtensionPointUtil.process(StyleContent.XPID, p);

	}

	class URLProcessor implements ExtensionPointProcessor {
		boolean found = false;

		Object style = null;

		String id;

		URL url;

		IProgressMonitor monitor;

		public URLProcessor(URL url, IProgressMonitor monitor) {
			this.url = url;
			this.monitor = monitor;
		}

		/*
		 * @see net.refractions.udig.core.internal.ExtensionPointProcessor#process(org.eclipse.core.runtime.IExtension,
		 *      org.eclipse.core.runtime.IConfigurationElement)
		 */
		public void process(IExtension extension, IConfigurationElement element)
				throws Exception {
			if (found)
				return;

			StyleContent styleContent = (StyleContent) element
					.createExecutableExtension("class"); //$NON-NLS-1$
			style = styleContent.load(url, monitor);
			if (style != null) {
				id = styleContent.getId();
				id2content.put(styleContent.getId(), styleContent);
				found = true;
			}
		}
	}

	/**
	 * @generated NOT
	 */
	private Object createStyleEntry(URL url, IProgressMonitor monitor) {
		URLProcessor p = new URLProcessor(url, monitor);
		ExtensionPointUtil.process(StyleContent.XPID, p);

		if (p.style != null) {
			put(p.id, p.style);
		}

		return p.style;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Object remove(String styleId) {
		Object style = null;
		for (Iterator seItr = getContent().iterator(); seItr.hasNext();) {
			StyleEntry se = (StyleEntry) seItr.next();
			if (se.getID().equals(styleId)) {
				style = se.getStyle();
				seItr.remove();
			}
		}

		return style;
	}

	/**
	 * <!-- begin-user-doc --> TODO: This method does not actually clone the underlying style
	 * objects, which it should. <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Object clone() {
		// clone the entrire blackboard
		StyleBlackboard clone = ProjectFactory.eINSTANCE
				.createStyleBlackboard();

		for (Iterator seItr = getContent().iterator(); seItr.hasNext();) {
			StyleEntry styleEntry = (StyleEntry) seItr.next();
			StyleContent styleContent = getStyleContent(styleEntry.getID());

			StyleEntry styleEntryClone = ProjectFactory.eINSTANCE
					.createStyleEntry();

			// clone the entry by copying the id + memento over
			styleEntryClone.setID(styleEntry.getID());
			styleEntryClone.setMemento(styleEntry.getMemento());
			clone.getContent().add(styleEntryClone);
		}

		return clone;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case ProjectPackage.STYLE_BLACKBOARD__CONTENT:
				return ((InternalEList) getContent()).basicRemove(otherEnd,
						msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.STYLE_BLACKBOARD__CONTENT:
			return getContent();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.STYLE_BLACKBOARD__CONTENT:
			getContent().clear();
			getContent().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.STYLE_BLACKBOARD__CONTENT:
			getContent().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case ProjectPackage.STYLE_BLACKBOARD__CONTENT:
			return content != null && !content.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * @see net.refractions.udig.project.IBlackboard#getFloat(java.lang.String)
	 */
	public Float getFloat(String key) {
		if (contains(key)) {
			Object value = get(key);
			if (value instanceof Float) {
				return (Float) value;
			}
		}
		return null;
	}

	public Integer getInteger(String key) {
		if (contains(key)) {
			Object value = get(key);
			if (value instanceof Integer) {
				return (Integer) value;
			}
		}
		return null;
	}

	public String getString(String key) {
		if (contains(key)) {
			Object value = get(key);
			if (value instanceof String) {
				return (String) value;
			}
		}
		return null;
	}

	public void putFloat(String key, float value) {
		put(key, value);
	}

	public void putInteger(String key, int value) {
		put(key, value);
	}

	public void putString(String key, String value) {
		put(key, value);
	}

	public void clear() {
		content.clear();
	}

	public void flush() {

	}

} // StyleBlackboardImpl
