/**
 * <copyright></copyright> $Id$
 */
package net.refractions.udig.project.internal.render.impl;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;

import net.refractions.udig.catalog.IGeoResource;
import net.refractions.udig.project.ILayer;
import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.impl.AbstractContextImpl;
import net.refractions.udig.project.internal.render.RenderContext;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.internal.render.RenderPackage;
import net.refractions.udig.project.internal.render.SelectionLayer;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.geotools.data.Query;

/**
 * Standard RenderContext implementation.  
 * @author   Jesse
 * @since   1.0.0
 * @generated
 */
public class RenderContextImpl extends AbstractContextImpl implements RenderContext {
	public static final String TRACE_ID="net.refractions.udig.project/debug/render/context"; //$NON-NLS-1$
    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

    /**
     * The default value of the '{@link #getImage() <em>Image</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getImage()
     * @generated
     * @ordered
     */
    protected static final BufferedImage IMAGE_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getImage() <em>Image</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getImage()
     * @generated NOT
     * @ordered
     */
    protected volatile BufferedImage image = IMAGE_EDEFAULT;

    protected static final BufferedImage dummyImage = new BufferedImage(1, 1, BufferedImage.TYPE_4BYTE_ABGR);

    /**
     * The default value of the '{@link #getZorder() <em>Zorder</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getZorder()
     * @generated
     * @ordered
     */
    protected static final int ZORDER_EDEFAULT = 0;

    /**
     * The default value of the '{@link #isVisible() <em>Visible</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #isVisible()
     * @generated
     * @ordered
     */
    protected static final boolean VISIBLE_EDEFAULT = false;

    /**
     * The cached value of the '{@link #getLayerInternal() <em>Layer Internal</em>}' reference.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getLayerInternal()
     * @generated
     * @ordered
     */
    protected Layer layerInternal = null;

    /**
     * The default value of the '{@link #getGeoResourceInternal() <em>Geo Resource Internal</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getGeoResourceInternal()
     * @generated
     * @ordered
     */
    protected static final IGeoResource GEO_RESOURCE_INTERNAL_EDEFAULT = null;

    /**
     * The cached value of the '{@link #getGeoResourceInternal() <em>Geo Resource Internal</em>}' attribute.
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @see #getGeoResourceInternal()
     * @generated
     * @ordered
     */
    protected IGeoResource geoResourceInternal = GEO_RESOURCE_INTERNAL_EDEFAULT;

    private boolean selection;

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected RenderContextImpl() {
        super();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     */
    protected RenderContextImpl( boolean selection ) {
        super();
        this.selection = selection;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    protected EClass eStaticClass() {
        return RenderPackage.eINSTANCE.getRenderContext();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @uml.property   name="image"
     * @generated  NOT
     */
    public BufferedImage getImage() {
        int width = getMapDisplay().getWidth(), height = getMapDisplay().getHeight();
        return getImage(width, height);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public synchronized BufferedImage getImage( int width, int height ) {

        if (width < 1 || height < 1)
            return dummyImage;

        if (image == null || image.getWidth() < width || image.getHeight() < height) {
            synchronized (this) {
                if (image == null || image.getWidth() < width || image.getHeight() < height) {
                    image = new BufferedImage(width, height, BufferedImage.TYPE_4BYTE_ABGR);
                }

            }
        }
        return image;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public Query getQuery( ILayer layer ) {
        return layer.getQuery(selection);
    }

    /**
     * <!-- begin-user-doc -->
     * <p>
     * Default behavior is to return 0 if no layers are associated otherwise
     * returns the zorder of the first layer in the list.
     * </p>
     * 
     * @return Default behavior is to return 0 if no layers are associated
     *         otherwise returns the zorder of the first layer in the list. <!--
     *         end-user-doc -->
     * @generated NOT
     */
    public int getZorder() {
        if (getLayer() == null) {
            return 0;
        }
        return getLayer().getZorder();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public boolean isVisible() {
        return getLayer().isVisible();
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Layer getLayerInternal() {
        return layerInternal;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void setLayerInternal( Layer newLayerInternal ) {
        Layer oldLayerInternal = layerInternal;
        layerInternal = newLayerInternal;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RenderPackage.RENDER_CONTEXT__LAYER_INTERNAL, oldLayerInternal, layerInternal));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public IGeoResource getGeoResourceInternal() {
        return geoResourceInternal;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void setGeoResourceInternal( IGeoResource newGeoResourceInternal ) {
        IGeoResource oldGeoResourceInternal = geoResourceInternal;
        geoResourceInternal = newGeoResourceInternal;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET,
                    RenderPackage.RENDER_CONTEXT__GEO_RESOURCE_INTERNAL, oldGeoResourceInternal,
                    geoResourceInternal));
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public Object eGet( EStructuralFeature eFeature, boolean resolve ) {
        switch( eDerivedStructuralFeatureID(eFeature) ) {
        case RenderPackage.RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
            return getRenderManagerInternal();
        case RenderPackage.RENDER_CONTEXT__MAP_INTERNAL:
            return getMapInternal();
        case RenderPackage.RENDER_CONTEXT__IMAGE:
            return getImage();
        case RenderPackage.RENDER_CONTEXT__ZORDER:
            return new Integer(getZorder());
        case RenderPackage.RENDER_CONTEXT__VISIBLE:
            return isVisible() ? Boolean.TRUE : Boolean.FALSE;
        case RenderPackage.RENDER_CONTEXT__LAYER_INTERNAL:
            return getLayerInternal();
        case RenderPackage.RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
            return getGeoResourceInternal();
        }
        return eDynamicGet(eFeature, resolve);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void eSet( EStructuralFeature eFeature, Object newValue ) {
        switch( eDerivedStructuralFeatureID(eFeature) ) {
        case RenderPackage.RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
            setRenderManagerInternal((RenderManager) newValue);
            return;
        case RenderPackage.RENDER_CONTEXT__MAP_INTERNAL:
            setMapInternal((Map) newValue);
            return;
        case RenderPackage.RENDER_CONTEXT__LAYER_INTERNAL:
            setLayerInternal((Layer) newValue);
            return;
        case RenderPackage.RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
            setGeoResourceInternal((IGeoResource) newValue);
            return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public void eUnset( EStructuralFeature eFeature ) {
        switch( eDerivedStructuralFeatureID(eFeature) ) {
        case RenderPackage.RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
            setRenderManagerInternal((RenderManager) null);
            return;
        case RenderPackage.RENDER_CONTEXT__MAP_INTERNAL:
            setMapInternal((Map) null);
            return;
        case RenderPackage.RENDER_CONTEXT__LAYER_INTERNAL:
            setLayerInternal((Layer) null);
            return;
        case RenderPackage.RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
            setGeoResourceInternal(GEO_RESOURCE_INTERNAL_EDEFAULT);
            return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * @generated
     */
    public boolean eIsSet( EStructuralFeature eFeature ) {
        switch( eDerivedStructuralFeatureID(eFeature) ) {
        case RenderPackage.RENDER_CONTEXT__RENDER_MANAGER_INTERNAL:
            return renderManagerInternal != null;
        case RenderPackage.RENDER_CONTEXT__MAP_INTERNAL:
            return mapInternal != null;
        case RenderPackage.RENDER_CONTEXT__IMAGE:
            return IMAGE_EDEFAULT == null ? image != null : !IMAGE_EDEFAULT.equals(image);
        case RenderPackage.RENDER_CONTEXT__ZORDER:
            return getZorder() != ZORDER_EDEFAULT;
        case RenderPackage.RENDER_CONTEXT__VISIBLE:
            return isVisible() != VISIBLE_EDEFAULT;
        case RenderPackage.RENDER_CONTEXT__LAYER_INTERNAL:
            return layerInternal != null;
        case RenderPackage.RENDER_CONTEXT__GEO_RESOURCE_INTERNAL:
            return GEO_RESOURCE_INTERNAL_EDEFAULT == null
                    ? geoResourceInternal != null
                    : !GEO_RESOURCE_INTERNAL_EDEFAULT.equals(geoResourceInternal);
        }
        return eDynamicIsSet(eFeature);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated NOT
     */
    public String toString() {
        StringBuffer result = new StringBuffer();
        result.append("layer: "); //$NON-NLS-1$
        result.append(layerInternal);
        result.append(", geoResource: "); //$NON-NLS-1$
        result.append(geoResourceInternal);
        result.append(')');
        return result.toString();
    }

    /**
     * @see net.refractions.udig.project.internal.AbstractContext#clone()
     */
    public Object clone() {
        RenderContextImpl tools = new RenderContextImpl(selection);
        tools.setMapInternal(getMapInternal());
        tools.setRenderManagerInternal(getRenderManagerInternal());
        tools.setLayerInternal(getLayerInternal());
        tools.setGeoResourceInternal(getGeoResourceInternal());
        return tools;
    }

    /**
     * TODO summary sentence for test ...
     * 
     * @see net.refractions.udig.project.internal.render.RenderContext#hasContent(java.awt.Point)
     * @param screenLocation
     * @return
     */
    public boolean hasContent( Point screenLocation ) {
        // BufferedImage image = getImage();
        // ColorModel cm = image.getColorModel();
        // SampleModel sm = image.getSampleModel();
        // WritableRaster raster = image.getRaster();
        //        
        //        
        // Object array;
        // switch( sm.getTransferType() ){
        // case DataBuffer.TYPE_BYTE:
        // array = raster.getPixel( screenLocation.x, screenLocation.y, new
        // byte[
        // raster.getNumBands() ] );
        // break;
        // case DataBuffer.TYPE_USHORT:
        // array = raster.getPixel( screenLocation.x, screenLocation.y, new
        // short[
        // raster.getNumBands() ] );
        // break;
        // case DataBuffer.TYPE_INT:
        // array = raster.getPixel( screenLocation.x, screenLocation.y, new int[
        // raster.getNumBands() ] );
        // break;
        // default:
        // return false; // I give up
        // }
        // cm.getAlpha( array );
        return false;
    }

    /**
     * TODO summary sentence for grabImage ...
     * 
     * @see net.refractions.udig.project.internal.render.RenderContext#copyImage(java.awt.Rectangle)
     * @param rectangle
     * @return
     */
    public BufferedImage copyImage( Rectangle rectangle ) {
        return null;
    }

    /**
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo( RenderContext o ) {
        return -1 * getLayer().compareTo(o.getLayer());
    }

    /**
     * @see net.refractions.udig.project.internal.render.RenderContext#init(net.refractions.udig.project.render.RenderContext)
     */
    public void init( RenderContext renderContext ) {
        setMapInternal(renderContext.getMapInternal());
        setRenderManagerInternal(renderContext.getRenderManagerInternal());
        setLayerInternal(renderContext.getLayerInternal());
        setGeoResourceInternal(renderContext.getGeoResourceInternal());
    }

    /**
     * @see net.refractions.udig.project.internal.render.RenderContext#clearImage()
     */
    public void clearImage() {
        clearImage(new Rectangle(0, 0, getMapDisplay().getWidth(), getMapDisplay().getHeight()));
    }

    /**
     * @see net.refractions.udig.project.internal.render.RenderContext#getFeatureQuery()
     */
    public Query getFeatureQuery() {
        return getLayer().getQuery(getLayer() instanceof SelectionLayer);
    }

    /**
     * @see net.refractions.udig.project.internal.render.RenderContext#clearImage(java.awt.Rectangle)
     */
    public synchronized void clearImage( Rectangle paintArea ) {
        Graphics2D graphics = getImage().createGraphics();
        graphics.setBackground(new Color(0, 0, 0, 0));
        graphics.setTransform(new AffineTransform());
        graphics.clearRect(paintArea.x, paintArea.y, paintArea.width, paintArea.height);
    }

    /**
     * @see net.refractions.udig.project.internal.render.RenderContext#setStatus(int)
     */
    public void setStatus( int status ) {
        if (layerInternal != null && !(layerInternal instanceof SelectionLayer))
            layerInternal.setStatus(status);
    }

    /**
     * @see net.refractions.udig.project.render.IRenderContext#getLayer()
     */
    public ILayer getLayer() {
        return getLayerInternal();
    }

    /**
     * @see net.refractions.udig.project.render.IRenderContext#getGeoResourceInternal()
     */
    public IGeoResource getGeoResource() {
        return getGeoResourceInternal();
    }

    /**
     * @see net.refractions.udig.project.render.IRenderContext#getStatus()
     */
    public int getStatus() {
        return getLayer().getStatus();
    }

    /**
     * @see net.refractions.udig.project.render.IRenderContext#getStatusMessage()
     */
    public String getStatusMessage() {
        return getLayer().getStatusMessage();
    }

    /**
     * @see net.refractions.udig.project.render.IRenderContext#setStatusMessage(java.lang.String)
     */
    public void setStatusMessage( String message ) {
        if (getLayerInternal() != null)
            getLayerInternal().setStatusMessage(message);
    }
    
    /**
     * Dispose of the resources held by this context.
     */
    public void dispose() {
    	image=null;
	}
} // RenderContextImpl
