/**
 * <copyright></copyright> $Id: ViewportModelImpl.java 16389 2005-10-16 23:19:08Z jeichar $
 */
package net.refractions.udig.project.internal.render.impl;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.io.IOException;

import net.refractions.udig.project.IMap;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.ProjectPackage;
import net.refractions.udig.project.internal.ProjectPlugin;
import net.refractions.udig.project.internal.render.RenderFactory;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.internal.render.RenderPackage;
import net.refractions.udig.project.internal.render.ViewportModel;
import net.refractions.udig.project.render.displayAdapter.IMapDisplay;
import net.refractions.udig.project.render.displayAdapter.MapDisplayEvent;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.notify.impl.AdapterImpl;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.geotools.factory.Hints;
import org.geotools.geometry.JTS;
import org.geotools.referencing.CRS;
import org.geotools.referencing.FactoryFinder;
import org.geotools.referencing.GeodeticCalculator;
import org.geotools.referencing.crs.DefaultGeographicCRS;
import org.opengis.referencing.FactoryException;
import org.opengis.referencing.NoSuchAuthorityCodeException;
import org.opengis.referencing.crs.CoordinateReferenceSystem;
import org.opengis.referencing.operation.CoordinateOperationFactory;
import org.opengis.referencing.operation.MathTransform;
import org.opengis.referencing.operation.TransformException;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Envelope;

/**
 * TODO Purpose of net.refractions.udig.project.internal.render.impl
 * <p>
 * </p>
 * 
 * @author Jesse
 * @since 1.0.0
 * @generated
 */
public class ViewportModelImpl extends EObjectImpl implements ViewportModel {
	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public static final String copyright = "uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004, Refractions Research Inc. This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; version 2.1 of the License. This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details."; //$NON-NLS-1$

	/**
	 * The default value of the '{@link #getCRS() <em>CRS</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCRS()
	 * @generated NOT
	 * @ordered
	 */
	public static final CoordinateReferenceSystem CRS_EDEFAULT = getDefaultCRS();

	/**
	 * The cached value of the '{@link #getCRS() <em>CRS</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCRS()
	 * @generated
	 * @ordered
	 */
	protected CoordinateReferenceSystem cRS = CRS_EDEFAULT;

	/**
	 * This is true if the CRS attribute has been set. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 * @ordered
	 */
	protected boolean cRSESet = false;

	/**
	 * The default value of the '{@link #getBounds() <em>Bounds</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBounds()
	 * @generated
	 * @ordered
	 */
	protected static final Envelope BOUNDS_EDEFAULT = (Envelope) RenderFactory.eINSTANCE
			.createFromString(RenderPackage.eINSTANCE.getEnvelope(), ""); //$NON-NLS-1$

	/**
	 * The cached value of the '{@link #getBounds() <em>Bounds</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getBounds()
	 * @generated
	 * @ordered
	 */
	protected Envelope bounds = BOUNDS_EDEFAULT;

	/**
	 * The default value of the '{@link #getCenter() <em>Center</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getCenter()
	 * @generated
	 * @ordered
	 */
	protected static final Coordinate CENTER_EDEFAULT = null;

	/**
	 * The default value of the '{@link #getHeight() <em>Height</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getHeight()
	 * @generated
	 * @ordered
	 */
	protected static final double HEIGHT_EDEFAULT = 0.0;

	/**
	 * The default value of the '{@link #getWidth() <em>Width</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getWidth()
	 * @generated
	 * @ordered
	 */
	protected static final double WIDTH_EDEFAULT = 0.0;

	/**
	 * The default value of the '{@link #getAspectRatio() <em>Aspect Ratio</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAspectRatio()
	 * @generated
	 * @ordered
	 */
	protected static final double ASPECT_RATIO_EDEFAULT = 0.0;

	/**
	 * The default value of the '{@link #getPixelSize() <em>Pixel Size</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPixelSize()
	 * @generated
	 * @ordered
	 */
	protected static final Coordinate PIXEL_SIZE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRenderManagerInternal() <em>Render Manager Internal</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getRenderManagerInternal()
	 * @generated
	 * @ordered
	 */
	protected RenderManager renderManagerInternal = null;

	AdapterImpl renderManagerListener = new AdapterImpl() {
		/**
		 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
		 */
		public void notifyChanged(Notification msg) {
			switch (msg.getFeatureID(RenderManager.class)) {
			case RenderPackage.RENDER_MANAGER__MAP_DISPLAY:
				sizeChanged(new MapDisplayEvent(getRenderManagerInternal()
						.getMapDisplay(), msg.getOldValue() == null ? null
						: ((IMapDisplay) msg.getOldValue()).getDisplaySize(),
						((IMapDisplay) msg.getNewValue()).getDisplaySize()));
				break;

			default:
				break;
			}
		}
	};

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")//$NON-NLS-1$
	protected ViewportModelImpl() {
		super();
		eAdapters().add(new AdapterImpl() {
			/**
			 * @see org.eclipse.emf.common.notify.impl.AdapterImpl#notifyChanged(org.eclipse.emf.common.notify.Notification)
			 */
			public void notifyChanged(Notification msg) {
				switch (msg.getFeatureID(ViewportModel.class)) {
				case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL: {
					if (msg.getOldValue() != null)
						((RenderManager) msg.getOldValue()).eAdapters().remove(
								renderManagerListener);
					if (msg.getNewValue() != null)
						((RenderManager) msg.getNewValue()).eAdapters().add(
								renderManagerListener);
					break;
				}// case
				}// switch
			}
		});
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return RenderPackage.eINSTANCE.getViewportModel();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public CoordinateReferenceSystem getCRS() {
		return cRS;
	}

	/**
	 * @see net.refractions.udig.project.internal.render.ViewportModel#setCRS(org.opengis.referencing.crs.CoordinateReferenceSystem)
	 * @uml.property name="cRS"
	 */
	public void setCRS(CoordinateReferenceSystem newCRS) {
		if (newCRS == null)
			throw new IllegalArgumentException("A CRS cannot be null"); //$NON-NLS-1$
		CoordinateReferenceSystem oldCRS = getCRS();
		try{
		if( CRS.transform(oldCRS, newCRS,true).isIdentity() )
			return;
		}catch(Exception e){}
		if (getBounds().isNull()) {
			setCRSGen(newCRS);
			if (eNotificationRequired())
				eNotify(new ENotificationImpl(this, Notification.SET,
						RenderPackage.VIEWPORT_MODEL__CRS, oldCRS, cRS));
		} else {
			try {
				setCRSGen(newCRS);
				MathTransform transform = CRS.transform(oldCRS, newCRS, true);
				// FIXME need to ensure that new bounds is a valid area.
				zoomToBox(JTS.transform(bounds, transform));
			} catch (Exception e) {
				zoomToExtent();
			}
		}
	}

	/**
	 * @generated
	 */
	public void setCRSGen(CoordinateReferenceSystem newCRS) {
		CoordinateReferenceSystem oldCRS = cRS;
		cRS = newCRS;
		boolean oldCRSESet = cRSESet;
		cRSESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					RenderPackage.VIEWPORT_MODEL__CRS, oldCRS, cRS, !oldCRSESet));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void unsetCRS() {
		CoordinateReferenceSystem oldCRS = cRS;
		boolean oldCRSESet = cRSESet;
		cRS = CRS_EDEFAULT;
		cRSESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET,
					RenderPackage.VIEWPORT_MODEL__CRS, oldCRS, CRS_EDEFAULT,
					oldCRSESet));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isSetCRS() {
		return cRSESet;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Envelope getBounds() {
		return bounds;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @uml.property name="bounds"
	 * @generated NOT
	 */
	public void setBounds(Envelope newBounds) {
		Envelope oldBounds = bounds == null ? new Envelope() : bounds;
		if (!getBounds().isNull() && !Double.isNaN(getAspectRatio())
				&& !Double.isNaN(newBounds.getWidth())
				&& !Double.isNaN(newBounds.getHeight())) {
			double nRatio = newBounds.getWidth() / newBounds.getHeight();
			if (Double.isNaN(nRatio))
				nRatio = 0.0;
			double dRatio = getAspectRatio();
			if (Math.abs(nRatio - dRatio) > ACCURACY) {
				// Returning the same newBounds box is ok, but sometimes causes
				// an infinite loop if
				// zoomToBox's calculations don't affect the size. Making this
				// arbitrary change to the
				// x-axis solves the problem.
				newBounds.init(newBounds.getMinX() - 2 * ACCURACY, newBounds
						.getMaxX()
						+ 2 * ACCURACY, newBounds.getMinY(), newBounds
						.getMaxY());

				zoomToBox(newBounds);
				return;
			}
		}
		bounds = newBounds;
		fireNotification(oldBounds);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Coordinate getCenter() {
		return new Coordinate(bounds.getMinX() + bounds.getWidth() / 2, bounds
				.getMinY()
				+ bounds.getHeight() / 2);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setCenter(Coordinate newCenter) {
		// Coordinate center=getCenter();
		double dw = getBounds().getWidth() / 2, dh = getBounds().getHeight() / 2;
		setBounds(new Envelope(newCenter.x - dw, newCenter.x + dw, newCenter.y
				- dh, newCenter.y + dh));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public double getHeight() {
		return bounds.getHeight();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setHeight(double newHeight) {
		setZoom(getHeight() / newHeight);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public double getWidth() {
		return getBounds().getWidth();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setWidth(double newWidth) {
		setZoom(getWidth() / newWidth);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public double getAspectRatio() {
		if (!validState())
			return Double.NaN;
		return getRenderManagerInternal().getMapDisplay().getWidth()
				/ (double) getRenderManagerInternal().getMapDisplay()
						.getHeight();
	}

	/**
	 * TODO summary sentence for validState ...
	 * 
	 * @return validState
	 */
	private boolean validState() {
		return getRenderManagerInternal() != null
				&& getRenderManagerInternal().getMapDisplay() != null
				&& getRenderManagerInternal().getMapDisplay().getDisplaySize() != null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Map getMapInternal() {
		if (eContainerFeatureID != RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL)
			return null;
		return (Map) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setMapInternalGen(Map newMapInternal) {
		if (newMapInternal != eContainer
				|| (eContainerFeatureID != RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL && newMapInternal != null)) {
			if (EcoreUtil.isAncestor(this, (EObject) newMapInternal))
				throw new IllegalArgumentException(
						"Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newMapInternal != null)
				msgs = ((InternalEObject) newMapInternal).eInverseAdd(this,
						ProjectPackage.MAP__VIEWPORT_MODEL_INTERNAL, Map.class,
						msgs);
			msgs = eBasicSetContainer((InternalEObject) newMapInternal,
					RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL, newMapInternal,
					newMapInternal));
	}

	boolean viewer = false;

	private static final double ACCURACY = 0.0000001;

	private boolean initialized;

	/**
	 * @return Returns the viewer.
	 * @uml.property name="viewer"
	 */
	public boolean isViewer() {
		return viewer;
	}

	/**
	 * @param viewer
	 *            The viewer to set.
	 * @uml.property name="viewer"
	 */
	public void setViewer(boolean viewer) {
		this.viewer = viewer;
	}

	/**
	 * @see net.refractions.udig.project.internal.render.RenderManager#setMap(net.refractions.udig.project.Map)
	 */
	public void setMapInternal(Map newMap) {
		if (isViewer()) {
			eBasicSetContainer((InternalEObject) newMap,
					RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL);
		} else
			setMapInternalGen(newMap);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public RenderManager getRenderManagerInternal() {
		return renderManagerInternal;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetRenderManagerInternal(
			RenderManager newRenderManagerInternal, NotificationChain msgs) {
		RenderManager oldRenderManagerInternal = renderManagerInternal;
		renderManagerInternal = newRenderManagerInternal;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this,
					Notification.SET,
					RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL,
					oldRenderManagerInternal, newRenderManagerInternal);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setRenderManagerInternal(RenderManager newRenderManagerInternal) {
		if (newRenderManagerInternal != renderManagerInternal) {
			NotificationChain msgs = null;
			if (renderManagerInternal != null)
				msgs = ((InternalEObject) renderManagerInternal)
						.eInverseRemove(
								this,
								RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL,
								RenderManager.class, msgs);
			if (newRenderManagerInternal != null)
				msgs = ((InternalEObject) newRenderManagerInternal)
						.eInverseAdd(
								this,
								RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL,
								RenderManager.class, msgs);
			msgs = basicSetRenderManagerInternal(newRenderManagerInternal, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL,
					newRenderManagerInternal, newRenderManagerInternal));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Coordinate getPixelSize() {
		return new Coordinate(getXPixelToWorldScale(), getYPixelToWorldScale());
	}

	private double getXPixelToWorldScale() {
		if (!validState())
			return Double.NaN;
		return getWidth()
				/ getRenderManagerInternal().getMapDisplay().getWidth();
	}

	private double getYPixelToWorldScale() {
		if (!validState())
			return Double.NaN;
		return getHeight()
				/ getRenderManagerInternal().getMapDisplay().getHeight();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void setBounds(double minx, double maxx, double miny, double maxy) {
		setBounds(new Envelope(minx, maxx, miny, maxy));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public AffineTransform worldToScreenTransform() {
		if (!validState())
			return null;
		// set up the affine transform and calculate scale values
		return worldToScreenTransform(getBounds(), getRenderManagerInternal()
				.getMapDisplay().getDisplaySize());
	}

	/**
	 * @see ViewportModel#worldToScreenTransform(Envelope, Dimension)
	 */
	public AffineTransform worldToScreenTransform(Envelope mapExtent,
			Dimension screenSize) {
		double scaleX = screenSize.getWidth() / mapExtent.getWidth();
		double scaleY = screenSize.getHeight() / mapExtent.getHeight();

		double tx = -mapExtent.getMinX() * scaleX;
		double ty = (mapExtent.getMinY() * scaleY) + screenSize.getHeight();

		AffineTransform at = new AffineTransform(scaleX, 0.0d, 0.0d, -scaleY,
				tx, ty);

		return at;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Point worldToPixel(Coordinate coord) {
		if (!validState())
			return null;
		Point2D w = new Point2D.Double(coord.x, coord.y);
		AffineTransform at = worldToScreenTransform();
		Point2D p = at.transform(w, new Point2D.Double());
		return new Point((int) p.getX(), (int) p.getY());
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public Coordinate pixelToWorld(int x, int y) {
		if (!validState())
			return null;
		// set up the affine transform and calculate scale values
		AffineTransform at = worldToScreenTransform(getBounds(),
				getRenderManagerInternal().getMapDisplay().getDisplaySize());

		try {
			Point2D result = at.inverseTransform(
					new java.awt.geom.Point2D.Double(x, y),
					new java.awt.geom.Point2D.Double());
			Coordinate c = new Coordinate(result.getX(), result.getY());

			return c;
		} catch (Exception e) {
			// TODO
			e.printStackTrace();
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public ViewportModel panUsingScreenCoords(int xpixels, int ypixels) {
		if (!validState())
			return this;
		panUsingWorldCoords(xpixels * getXPixelToWorldScale(), -ypixels
				* getYPixelToWorldScale());
		return this;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public ViewportModel panUsingWorldCoords(double x, double y) {
		Envelope bounds = getBounds();
		setBounds(bounds.getMinX() + x, bounds.getMaxX() + x, bounds.getMinY()
				+ y, bounds.getMaxY() + y);
		return this;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public ViewportModel setZoom(double zoom) {
		Coordinate center = getCenter();
		double height = getHeight() / zoom, width = getWidth() / zoom;
		double dh = height / 2, dw = width / 2;
		setBounds(center.x - dw, center.x + dw, center.y - dh, center.y + dh);
		return this;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated NOT
	 */
	public void zoomToExtent() {
		try {
			if (!validState())
				return;

			if (getMapInternal().getBounds(null).getCRS() == null
					|| getCRS() == null
					|| getMapInternal().getBounds(null).getCRS().equals(
							getCRS())) {
				zoomToBox(getMapInternal().getBounds(null));
			} else {
				MathTransform transform = null;
				transform = CRS.transform(getMapInternal().getBounds(null)
						.getCRS(), getCRS(), true);
				zoomToBox(JTS.transform(getMapInternal().getBounds(null),
						transform));
			}

		} catch (IOException e2) {
			zoomToBox(new Envelope(-180, 180, -90, 90));
		} catch (FactoryException e) {
			zoomToBox(new Envelope(-180, 180, -90, 90));
		} catch (TransformException e) {
			zoomToBox(new Envelope(-180, 180, -90, 90));
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd,
						RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL, msgs);
			case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
				if (renderManagerInternal != null)
					msgs = ((InternalEObject) renderManagerInternal)
							.eInverseRemove(
									this,
									RenderPackage.RENDER_MANAGER__VIEWPORT_MODEL_INTERNAL,
									RenderManager.class, msgs);
				return basicSetRenderManagerInternal((RenderManager) otherEnd,
						msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd,
			int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
				return eBasicSetContainer(null,
						RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL, msgs);
			case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
				return basicSetRenderManagerInternal(null, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass,
						msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
				return eContainer.eInverseRemove(this,
						ProjectPackage.MAP__VIEWPORT_MODEL_INTERNAL, Map.class,
						msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE
				- eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case RenderPackage.VIEWPORT_MODEL__CRS:
			return getCRS();
		case RenderPackage.VIEWPORT_MODEL__BOUNDS:
			return getBounds();
		case RenderPackage.VIEWPORT_MODEL__CENTER:
			return getCenter();
		case RenderPackage.VIEWPORT_MODEL__HEIGHT:
			return new Double(getHeight());
		case RenderPackage.VIEWPORT_MODEL__WIDTH:
			return new Double(getWidth());
		case RenderPackage.VIEWPORT_MODEL__ASPECT_RATIO:
			return new Double(getAspectRatio());
		case RenderPackage.VIEWPORT_MODEL__PIXEL_SIZE:
			return getPixelSize();
		case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
			return getMapInternal();
		case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
			return getRenderManagerInternal();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case RenderPackage.VIEWPORT_MODEL__CRS:
			setCRS((CoordinateReferenceSystem) newValue);
			return;
		case RenderPackage.VIEWPORT_MODEL__BOUNDS:
			setBounds((Envelope) newValue);
			return;
		case RenderPackage.VIEWPORT_MODEL__CENTER:
			setCenter((Coordinate) newValue);
			return;
		case RenderPackage.VIEWPORT_MODEL__HEIGHT:
			setHeight(((Double) newValue).doubleValue());
			return;
		case RenderPackage.VIEWPORT_MODEL__WIDTH:
			setWidth(((Double) newValue).doubleValue());
			return;
		case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
			setMapInternal((Map) newValue);
			return;
		case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
			setRenderManagerInternal((RenderManager) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case RenderPackage.VIEWPORT_MODEL__CRS:
			unsetCRS();
			return;
		case RenderPackage.VIEWPORT_MODEL__BOUNDS:
			setBounds(BOUNDS_EDEFAULT);
			return;
		case RenderPackage.VIEWPORT_MODEL__CENTER:
			setCenter(CENTER_EDEFAULT);
			return;
		case RenderPackage.VIEWPORT_MODEL__HEIGHT:
			setHeight(HEIGHT_EDEFAULT);
			return;
		case RenderPackage.VIEWPORT_MODEL__WIDTH:
			setWidth(WIDTH_EDEFAULT);
			return;
		case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
			setMapInternal((Map) null);
			return;
		case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
			setRenderManagerInternal((RenderManager) null);
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case RenderPackage.VIEWPORT_MODEL__CRS:
			return isSetCRS();
		case RenderPackage.VIEWPORT_MODEL__BOUNDS:
			return BOUNDS_EDEFAULT == null ? bounds != null : !BOUNDS_EDEFAULT
					.equals(bounds);
		case RenderPackage.VIEWPORT_MODEL__CENTER:
			return CENTER_EDEFAULT == null ? getCenter() != null
					: !CENTER_EDEFAULT.equals(getCenter());
		case RenderPackage.VIEWPORT_MODEL__HEIGHT:
			return getHeight() != HEIGHT_EDEFAULT;
		case RenderPackage.VIEWPORT_MODEL__WIDTH:
			return getWidth() != WIDTH_EDEFAULT;
		case RenderPackage.VIEWPORT_MODEL__ASPECT_RATIO:
			return getAspectRatio() != ASPECT_RATIO_EDEFAULT;
		case RenderPackage.VIEWPORT_MODEL__PIXEL_SIZE:
			return PIXEL_SIZE_EDEFAULT == null ? getPixelSize() != null
					: !PIXEL_SIZE_EDEFAULT.equals(getPixelSize());
		case RenderPackage.VIEWPORT_MODEL__MAP_INTERNAL:
			return getMapInternal() != null;
		case RenderPackage.VIEWPORT_MODEL__RENDER_MANAGER_INTERNAL:
			return renderManagerInternal != null;
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (cRS: "); //$NON-NLS-1$
		if (cRSESet)
			result.append(cRS);
		else
			result.append("<unset>"); //$NON-NLS-1$
		result.append(", bounds: "); //$NON-NLS-1$
		result.append(bounds);
		result.append(')');
		return result.toString();
	}

	/**
	 * @see net.refractions.udig.project.render.displayAdapter.IMapDisplayListener#sizeChanged(net.refractions.udig.project.render.displayAdapter.MapDisplayEvent)
	 */
	public void sizeChanged(MapDisplayEvent event) {
		if (event.getSize().width < 1 || event.getSize().height < 1)
			return;

		Envelope oldBounds = getBounds();

		if (newSizeIsSmaller(event)) {
			calculateNewBounds(event, oldBounds);
			return;
		}
		if (oldBounds.isNull()) {
			zoomToExtent();
		} else {
			if (oldSizeIsValid(event)) {
				calculateNewBounds(event, oldBounds);

				fireNotification(oldBounds);
			} else {
				zoomToBox(getBounds());
			}
		}
	}

	private void fireNotification(Envelope oldBounds) {
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET,
					RenderPackage.VIEWPORT_MODEL__BOUNDS, oldBounds, bounds));
	}

	private void calculateNewBounds(MapDisplayEvent event, Envelope oldBounds) {
		double oldXscale = getWidth() / event.getOldSize().width;
		double oldYscale = getHeight() / event.getOldSize().height;
		double minx = oldBounds.getMinX();
		double maxy = oldBounds.getMaxY();
		double maxx = minx + (event.getSize().width * oldXscale);
		double miny = maxy - (event.getSize().height * oldYscale);
		this.bounds = new Envelope(minx, maxx, miny, maxy);
	}

	private boolean oldSizeIsValid(MapDisplayEvent event) {
		return event.getOldSize() != null && event.getOldSize().width != 0
				&& event.getOldSize().height != 0;
	}

	private boolean newSizeIsSmaller(MapDisplayEvent event) {
		if (event.getOldSize() == null)
			return false;
		return event.getOldSize().width > event.getSize().width
				&& event.getOldSize().height > event.getSize().height;
	}

	/**
	 * @see net.refractions.udig.project.internal.render.ViewportModel#zoomToBox(com.vividsolutions.jts.geom.Envelope)
	 */
	public void zoomToBox(Envelope newbbox) {
		setInitialized(true);
		if (Math.abs(newbbox.getWidth() / newbbox.getHeight()
				- this.getAspectRatio()) > ACCURACY) {
			IMapDisplay display = this.getRenderManagerInternal()
					.getMapDisplay();
			double scaley = newbbox.getHeight() / display.getHeight();
			double scalex = newbbox.getWidth() / display.getWidth();
			double scale;
			if (scalex > scaley)
				scale = scalex;
			else
				scale = scaley;

			double height = display.getHeight() * scale;
			double width = display.getWidth() * scale;

			double dw = width / 2, dh = height / 2;
			Envelope mapBounds = newbbox;
			double x = (mapBounds.getMaxX() + mapBounds.getMinX()) / 2;
			double y = (mapBounds.getMaxY() + mapBounds.getMinY()) / 2;
			newbbox.init(x - dw, x + dw, y - dh, y + dh);
			// newbbox.init(validateEnvelope(newbbox));
		}
		this.setBounds(newbbox);
	}

	// // will be used later
	// private Envelope validateEnvelope(Envelope newbbox) {
	// Extent validArea = getCRS().getValidArea();
	// // TODO remove when switch over in CRSService is made
	// if (validArea == null)
	// validArea = ViewportValidAreaHelper.createValidArea(getCRS());
	// if (validArea == null)
	// return newbbox;
	// if (validArea.getGeographicElement() != null) {
	// GeographicExtent geoExtent = validArea.getGeographicElement();
	// if (geoExtent instanceof GeographicBoundingBox) {
	// return validateEnvelope(newbbox,
	// (GeographicBoundingBox) geoExtent, getCRS()
	// .getCoordinateSystem());
	// } else if (geoExtent instanceof BoundingPolygon) {
	// // TODO
	// }
	// } else if (validArea.getVerticalElement() != null) {
	// // VerticalExtent verticalExtent = validArea.getVerticalElement();
	// // TODO
	// }
	// return newbbox;
	// }

	// //// private Envelope validateEnvelope(Envelope newbbox,
	// //// GeographicBoundingBox box, CoordinateSystem cs) {
	// ////
	// //// if (box.getInclusion()) {
	// //// double north = getNorthExtent(newbbox, cs);
	// //// double south = getSouthExtent(newbbox, cs);
	// //// double east = getEastExtent(newbbox, cs);
	// //// double west = getWestExtent(newbbox, cs);
	// ////
	// //// if (box.getNorthBoundLatitude() < getNorthExtent(newbbox, cs))
	// //// north = box.getNorthBoundLatitude();
	// //// if (box.getSouthBoundLatitude() < getSouthExtent(newbbox, cs))
	// //// south = box.getSouthBoundLatitude();
	// //// if (box.getEastBoundLongitude() < getEastExtent(newbbox, cs))
	// //// east = box.getEastBoundLongitude();
	// //// if (box.getWestBoundLongitude() < getWestExtent(newbbox, cs))
	// //// west = box.getWestBoundLongitude();
	// ////
	// //// setNorthExtent(newbbox, north, east, south, west, cs);
	// //// setSouthExtent(newbbox, north, east, south, west, cs);
	// //// setWestExtent(newbbox, north, east, south, west, cs);
	// //// setEastExtent(newbbox, north, east, south, west, cs);
	// //// } else {
	// //// // TODO exclusion box
	// //// }
	// //// return newbbox;
	// //// }
	// //
	// // /**
	// // * Finds the north coordinate in the bounding box according to the crs.
	// // *
	// // * @param newbbox
	// // * @return
	// // */
	// // private double getNorthExtent(Envelope newbbox, CoordinateSystem cs) {
	// // if (cs.getAxis(1).getDirection().equals(AxisDirection.NORTH))
	// // return newbbox.getMaxY();
	// // if (cs.getAxis(1).getDirection().equals(AxisDirection.SOUTH))
	// // return newbbox.getMinY();
	// // if (cs.getAxis(0).getDirection().equals(AxisDirection.NORTH))
	// // return newbbox.getMaxX();
	// // if (cs.getAxis(0).getDirection().equals(AxisDirection.SOUTH))
	// // return newbbox.getMinX();
	// // // TODO axis point at an angle SouthEast for example
	// // return newbbox.getMaxY();
	// // }
	//
	// /**
	// * Sets the north coordinate in the bounding box according to the crs.
	// */
	// private Envelope setNorthExtent(Envelope newbbox, double north,
	// double east, double south, double west, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.NORTH))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), newbbox
	// .getMinY(), north);
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.SOUTH))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), north,
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.NORTH))
	// return new Envelope(newbbox.getMinX(), north, newbbox.getMinY(),
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.SOUTH))
	// return new Envelope(north, newbbox.getMaxX(), newbbox.getMinY(),
	// newbbox.getMaxY());
	// // TODO axis point at an angle SouthEast for example
	// return newbbox;
	// }

	// /**
	// * Finds the South coordinate in the bounding box according to the crs.
	// *
	// * @param newbbox
	// * @return
	// */
	// private double getSouthExtent(Envelope newbbox, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.SOUTH))
	// return newbbox.getMaxY();
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.NORTH))
	// return newbbox.getMinY();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.SOUTH))
	// return newbbox.getMaxX();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.NORTH))
	// return newbbox.getMinX();
	// // TODO axis point at an angle SouthEast for example
	// return newbbox.getMinY();
	// }
	//
	// /**
	// * Sets the north coordinate in the bounding box according to the crs.
	// */
	// private Envelope setSouthExtent(Envelope newbbox, double north,
	// double east, double south, double west, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.SOUTH))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), newbbox
	// .getMinY(), south);
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.NORTH))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), south,
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.SOUTH))
	// return new Envelope(newbbox.getMinX(), south, newbbox.getMinY(),
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.NORTH))
	// return new Envelope(south, newbbox.getMaxX(), newbbox.getMinY(),
	// newbbox.getMaxY());
	// // TODO axis point at an angle SouthEast for example
	// return newbbox;
	// }
	//
	// /**
	// * Finds the EAST coordinate in the bounding box according to the crs.
	// *
	// * @param newbbox
	// * @return
	// */
	// private double getEastExtent(Envelope newbbox, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.EAST))
	// return newbbox.getMaxY();
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.WEST))
	// return newbbox.getMinY();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.EAST))
	// return newbbox.getMaxX();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.WEST))
	// return newbbox.getMinX();
	// // TODO axis point at an angle SouthEast for example
	// return newbbox.getMaxX();
	// }
	//
	// /**
	// * Sets the north coordinate in the bounding box according to the crs.
	// */
	// private Envelope setEastExtent(Envelope newbbox, double north, double
	// east,
	// double south, double west, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.EAST))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), newbbox
	// .getMinY(), east);
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.WEST))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), east,
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.EAST))
	// return new Envelope(newbbox.getMinX(), east, newbbox.getMinY(),
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.WEST))
	// return new Envelope(east, newbbox.getMaxX(), newbbox.getMinY(),
	// newbbox.getMaxY());
	// // TODO axis point at an angle SouthEast for example
	// return newbbox;
	// }
	//
	// /**
	// * Finds the West coordinate in the bounding box according to the crs.
	// *
	// * @param newbbox
	// * @return
	// */
	// private double getWestExtent(Envelope newbbox, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.WEST))
	// return newbbox.getMaxY();
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.EAST))
	// return newbbox.getMinY();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.WEST))
	// return newbbox.getMaxX();
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.EAST))
	// return newbbox.getMinX();
	// // TODO axis point at an angle SouthEast for example
	// return newbbox.getMaxX();
	// }
	//
	// /**
	// * Sets the north coordinate in the bounding box according to the crs.
	// */
	// private Envelope setWestExtent(Envelope newbbox, double north, double
	// east,
	// double south, double west, CoordinateSystem cs) {
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.WEST))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), newbbox
	// .getMinY(), west);
	// if (cs.getAxis(1).getDirection().equals(AxisDirection.EAST))
	// return new Envelope(newbbox.getMinX(), newbbox.getMaxX(), west,
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.WEST))
	// return new Envelope(newbbox.getMinX(), west, newbbox.getMinY(),
	// newbbox.getMaxY());
	// if (cs.getAxis(0).getDirection().equals(AxisDirection.EAST))
	// return new Envelope(west, newbbox.getMaxX(), newbbox.getMinY(),
	// newbbox.getMaxY());
	// // TODO axis point at an angle SouthEast for example
	// return newbbox;
	// }

	/**
	 * Returns the system wide default CRS
	 */
	public static CoordinateReferenceSystem getDefaultCRS() {
		try {
			return CRS.decode("EPSG:4326"); //$NON-NLS-1$
		} catch (NoSuchAuthorityCodeException e) {
			return DefaultGeographicCRS.WGS84;
		}
	}

	/**
	 * FIXME, This method was added as a work around for the fact that we do not
	 * have the ability to chain or batch commands.
	 * 
	 * @param firing
	 */
	public void setFiringEvents(boolean firing) {
		if (firing) {
			eFlags |= EDELIVER;
		} else {
			eFlags &= ~EDELIVER;

		}
	}

	/**
	 * @see net.refractions.udig.project.internal.render.ViewportModel#isInitialized()
	 * @uml.property name="initialized"
	 */
	public boolean isInitialized() {
		return initialized;
	}

	/**
	 * @param initialized
	 *            The initialized to set.
	 * @uml.property name="initialized"
	 */
	public void setInitialized(boolean initialized) {
		this.initialized = initialized;
	}

	/**
	 * @see net.refractions.udig.project.render.IViewportModel#getMap()
	 */
	public IMap getMap() {
		return getMapInternal();
	}
	public double getScaleDenominator() {
		if( getRenderManagerInternal()==null || getRenderManagerInternal().getMapDisplay()==null
				|| getRenderManagerInternal().getMapDisplay().getDPI()<=0 )
			return -1;
		
	
		Envelope translatedBounds;
		try {
			translatedBounds = JTS.toGeographic(getBounds(),getCRS());
			
		} catch (Exception e1) {
			ProjectPlugin.log("Error transforming "+getCRS().getName()+" to WGS84", e1); //$NON-NLS-1$ //$NON-NLS-2$
			return -1;
		} 
		Envelope world=new Envelope(-180,180,-90,90);
		if( world.contains(translatedBounds)){
			Point2D displaySize=new Point2D.Double( getRenderManagerInternal().getMapDisplay().getWidth(),
					getRenderManagerInternal().getMapDisplay().getHeight());
			return calculateScale(translatedBounds, displaySize);
		}else{
			Point2D screenDimension=new Point2D.Double();
			Envelope scaledBounds=calculateScaledBounds(translatedBounds, screenDimension);
			return calculateScale(scaledBounds, screenDimension);
		}
	}

	private Envelope calculateScaledBounds(Envelope translatedBounds, Point2D screenDimension) {
		Envelope result;
		Envelope world=new Envelope(-180,180,-90,90);
		double xratio = world.getWidth()/translatedBounds.getWidth();
		double yratio = world.getHeight()/translatedBounds.getHeight();
		if( xratio<yratio){
			// ratio between widths is greater so the scaled instance should be based on 
			// width.
			result=new Envelope(-180, 180, -90, -90+translatedBounds.getHeight()*xratio);
			screenDimension.setLocation(((double)getRenderManagerInternal().getMapDisplay().getWidth())*xratio,
					((double)getRenderManagerInternal().getMapDisplay().getHeight())*xratio);
		}else{
			// ratio between widths is greater so the scaled instance should be based on 
			// width.
			result=new Envelope(-180, -180+translatedBounds.getWidth()*yratio, -90, 90);
			screenDimension.setLocation(((double)getRenderManagerInternal().getMapDisplay().getWidth())*yratio,
					((double)getRenderManagerInternal().getMapDisplay().getHeight())*yratio);
			
		}
		return result;
	}

	private double calculateScale(Envelope restrictedBounds, Point2D screenDimension) {
		double diagonalGroundDistance;
		try {
			diagonalGroundDistance = CRS.distance(new Coordinate(restrictedBounds
					.getMinX(), restrictedBounds.getMinY()), new Coordinate(restrictedBounds
					.getMaxX(), restrictedBounds.getMaxY()), DefaultGeographicCRS.WGS84);
		} catch (Exception e) {
			ProjectPlugin.log("Error calculating cround distance", e); //$NON-NLS-1$
			return -1;
		}
		
		double displayWidth=screenDimension.getX();
		double displayHeight=screenDimension.getY();
		int DPI=getRenderManagerInternal().getMapDisplay().getDPI();
		
		// pythagorean theorem
		double diagonalPixelDistancePixels = Math.sqrt(displayWidth * displayWidth
				+ displayHeight * displayHeight);
		double diagonalPixelDistanceMeters = diagonalPixelDistancePixels / DPI
				* 2.54 / 100; // 2.54 = cm/inch, 100= cm/m

		return diagonalGroundDistance / diagonalPixelDistanceMeters; // remember,
																		// this
																		// is
																		// the
																		// denominator,
																		// not
																		// the
																		// actual
																		// scale;
	}

    private final static CoordinateOperationFactory distanceOperationFactory;
    static {
        Hints hints=new Hints(Hints.LENIENT_DATUM_SHIFT, Boolean.TRUE);
        distanceOperationFactory=FactoryFinder.getCoordinateOperationFactory(hints);
    }
    
    public void setScale( double scaleDenominator ) {
        double displayWidth=getRenderManagerInternal().getMapDisplay().getWidth();
        double displayHeight=getRenderManagerInternal().getMapDisplay().getHeight();
        int DPI=getRenderManagerInternal().getMapDisplay().getDPI();
        
        // pythagorean theorem
        double diagonalPixelDistancePixels = Math.sqrt(displayWidth * displayWidth
                + displayHeight * displayHeight);
        double diagonalPixelDistanceMeters = diagonalPixelDistancePixels / DPI
            * 2.54 / 100; // 2.54 = cm/inch, 100= cm/m
        
        double groundDistance = scaleDenominator*diagonalPixelDistanceMeters;
        
        GeodeticCalculator gc = new GeodeticCalculator();
        double[] cs        = new double[4];
        double[] csLatLong = new double[4];
         
        try{
            cs[0] = Math.max(getBounds().getMinX(), getMap().getBounds(null).getMinX());
            cs[1] = Math.max(getBounds().getMinX(), getMap().getBounds(null).getMinX());     

            MathTransform transform = distanceOperationFactory.createOperation(getCRS(),DefaultGeographicCRS.WGS84).getMathTransform();
            transform.transform(cs, 0, csLatLong, 0, 1);
            gc.setAnchorPoint(csLatLong[0], csLatLong[1]);
            
            gc.setDirection(45, groundDistance);
            Point2D latLongPosition = gc.getDestinationPoint();
            csLatLong[0] = latLongPosition.getX();
            csLatLong[1] = latLongPosition.getY();
            transform.inverse().transform(csLatLong,0, cs,2,1);
            
            // calculate amount to zoom
            setWidth(cs[2]-cs[0]);
        }catch (Exception e) {
            ProjectPlugin.log("", e); //$NON-NLS-1$
        }
    }

}
