/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui;

import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.project.ui.internal.Policy;
import net.refractions.udig.ui.operations.IOp;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;

import com.vividsolutions.jts.geom.Envelope;

/**
 * Displays a summary of the layer in a dialog.
 * 
 * @author jeichar
 * @since 0.6.0
 */
public class LayerSummary implements IOp {
	/**
	 * @see net.refractions.udig.ui.operations.IOp#op(org.eclipse.swt.widgets.Display, java.lang.Object, org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void op(final Display display, Object target, IProgressMonitor monitor) throws Exception {
        final Layer layer=(Layer) target;
		monitor.beginTask(Policy.bind("LayerSummary.0"), 1); //$NON-NLS-1$
        Envelope bounds=layer.getBounds(monitor, layer.getMap().getViewportModel().getCRS());
        final StringBuffer buffer=new StringBuffer();
        buffer.append(Policy.bind("LayerSummary.1")+layer.getName()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
        buffer.append(Policy.bind("LayerSummary.3")+layer.getID()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
        buffer.append(Policy.bind("LayerSummary.5")+layer.getZorder()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
        buffer.append(Policy.bind("LayerSummary.7")+layer.getCRS(monitor).getName()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
        buffer.append(Policy.bind("LayerSummary.9")+bounds.getMinX()+","+bounds.getMinY()+Policy.bind("LayerSummary.11")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
        buffer.append("            ("+bounds.getMaxX()+","+bounds.getMaxY()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
        buffer.append(Policy.bind("LayerSummary.15")+layer.getFilter()+"\n"); //$NON-NLS-1$ //$NON-NLS-2$
        display.asyncExec(new Runnable() {
			public void run() {
		        MessageDialog.openInformation(display.getActiveShell(), Policy.bind("LayerSummary.17")+layer.getName(), buffer.toString()); //$NON-NLS-1$
			}
		});
		monitor.internalWorked(1);
		monitor.done();
	}

}
