/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.internal;

import java.util.HashMap;
import java.util.Map;

import net.refractions.udig.project.IProjectElement;
import net.refractions.udig.project.ui.UDIGEditorInput;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;

/**
 * Provides ...TODO summary sentence
 * <p>
 * TODO Description
 * </p><p>
 * Responsibilities:
 * <ul>
 * <li>
 * <li>
 * </ul>
 * </p><p>
 * Example Use:<pre><code>
 * UDIGEditorInputDescriptor x = new UDIGEditorInputDescriptor( ... );
 * TODO code example
 * </code></pre>
 * </p>
 * @author jones
 * @since 0.3
 */
public class UDIGEditorInputDescriptor {
    protected String editorID;    
    protected String name;
    protected Class type;
    protected IConfigurationElement extensionElement;
    protected Map instances=new HashMap();
    /**
     * Creates a UDIGEditorInput
     * 
     * @param element
     * @return the EditorInput
     * @throws CoreException
     */
    public UDIGEditorInput createInput(IProjectElement element) throws CoreException{
        if( !instances.containsKey(element) ){
	        UDIGEditorInput input=(UDIGEditorInput) extensionElement.createExecutableExtension("class"); //$NON-NLS-1$
	        input.setProjectElement(element);
	        instances.put(element, input);
        }
        return (UDIGEditorInput) instances.get(element);
        
    }
        
    /**
     * @return Returns the type.
     */
    public Class getType() {
        return type;
    }
    /**
     * @param type The type to set.
     */
    public void setType( Class type ) {
        this.type = type;
    }
    /**
     * @return Returns the editorID.
     */
    public String getEditorID() {
        return editorID;
    }
    /**
     * @param editorID The editorID to set.
     */
    public void setEditorID( String editorID ) {
        this.editorID = editorID;
    }
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName( String name ) {
        this.name = name;
    }
    /**
     * @return Returns the extensionElement.
     */
    public IConfigurationElement getExtensionElement() {
        return extensionElement;
    }
    /**
     * @param extensionElement The extensionElement to set.
     */
    public void setExtensionElement( IConfigurationElement extensionElement ) {
        this.extensionElement = extensionElement;
    }

}
