package net.refractions.udig.project.ui.internal.actions;

import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.ui.IDropAction;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.viewers.ViewerDropAdapter;

public class LayerDropAction extends IDropAction {

	@Override
	public boolean accept(Object source, Object destination) {
		//all info declared in extension point, no further checks needed
		return true;  
	
	}

	@Override
	public void perform(Object source, Object destination, IProgressMonitor monitor) {
		Layer layer = (Layer)source;
		Layer target = (Layer)getDropHandler().getTarget();
		int location = getDropHandler().getLocation();
		
		 
        if (location == ViewerDropAdapter.LOCATION_NONE) {
            layer.setZorder(0);
            return;
        }
        
		//Moving something AFTER a layer is the same as moving something BEFORE a layer.
        //So we will use BEFORE as much as possible to prevent duplication here.
        //This code will retrieve the layer before. Or the first one, if we are at the 
        //beginning of the list.
		if (location == ViewerDropAdapter.LOCATION_AFTER) {
            int i = target.getZorder()-1;
            
            //In this case, they are dropping it AFTER the lowest (0) element
            if (i < 0) {
                target = target.getContextModel().getLayers().get(0);
                layer.setZorder(target.getZorder());
                return;
            }
            target = target.getContextModel().getLayers().get(i);
            
            if (layer.equals(target)) {
                return;
            }
        }
		int zLayer=layer.getZorder();
		int ztarget=target.getZorder();
        if ( zLayer > ztarget) {
            layer.setZorder(target.getZorder());            
        } else {
            layer.setZorder(target.getZorder());
        }
	}
}
	
