/**
 * <copyright>
 * </copyright>
 *
 * $Id: ToolContextImpl.java 15139 2005-08-05 00:12:28Z jeichar $
 */
package net.refractions.udig.project.ui.internal.tool.impl;

import net.refractions.udig.project.command.Command;
import net.refractions.udig.project.command.EditCommand;
import net.refractions.udig.project.command.EditCommandFactory;
import net.refractions.udig.project.command.EditManagerControlCommand;
import net.refractions.udig.project.command.MapCommand;
import net.refractions.udig.project.command.NavCommand;
import net.refractions.udig.project.command.NavigationCommandFactory;
import net.refractions.udig.project.command.SelectionCommandFactory;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.internal.impl.AbstractContextImpl;
import net.refractions.udig.project.internal.render.RenderManager;
import net.refractions.udig.project.ui.commands.DrawCommandFactory;
import net.refractions.udig.project.ui.commands.IDrawCommand;
import net.refractions.udig.project.ui.internal.tool.ToolContext;
import net.refractions.udig.project.ui.internal.tool.ToolPackage;
import net.refractions.udig.project.ui.render.displayAdapter.ViewportPane;

import org.eclipse.core.runtime.Plugin;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.PlatformUI;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>AbstractContext</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getContextModel <em>Context Model</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getPixelSize <em>Pixel Size</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getViewportModel <em>Viewport Model</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getEditManager <em>Edit Manager</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getRenderManager <em>Render Manager</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getMapDisplay <em>Map Display</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getMap <em>Map</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getProject <em>Project</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getViewportPane <em>Viewport Pane</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getDrawFactory <em>Draw Factory</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getEditFactory <em>Edit Factory</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getNavigationFactory <em>Navigation Factory</em>}</li>
 *   <li>{@link net.refractions.udig.project.ui.internal.tool.impl.ToolContextImpl#getSelectionFactory <em>Selection Factory</em>}</li>
 * </ul>
 * </p>
 *
 * @generated NOT
 */
public class ToolContextImpl extends AbstractContextImpl implements ToolContext {


    /**
     * The default value of the '{@link #getDrawFactory() <em>Draw Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDrawFactory()
     * @generated NOT
     * @ordered
     */
    protected static final DrawCommandFactory DRAW_FACTORY_EDEFAULT = DrawCommandFactory.getInstance();

    /**
     * The cached value of the '{@link #getDrawFactory() <em>Draw Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getDrawFactory()
     * @generated
     * @ordered
     */
    protected DrawCommandFactory drawFactory = DRAW_FACTORY_EDEFAULT;

    /**
     * The default value of the '{@link #getEditFactory() <em>Edit Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getEditFactory()
     * @generated NOT
     * @ordered
     */
    protected static final EditCommandFactory EDIT_FACTORY_EDEFAULT = EditCommandFactory.getInstance();

    /**
     * The cached value of the '{@link #getEditFactory() <em>Edit Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getEditFactory()
     * @generated
     * @ordered
     */
    protected EditCommandFactory editFactory = EDIT_FACTORY_EDEFAULT;

    /**
     * The default value of the '{@link #getNavigationFactory() <em>Navigation Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getNavigationFactory()
     * @generated NOT
     * @ordered
     */
    protected static final NavigationCommandFactory NAVIGATION_FACTORY_EDEFAULT = NavigationCommandFactory.getInstance();

    /**
     * The cached value of the '{@link #getNavigationFactory() <em>Navigation Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getNavigationFactory()
     * @generated
     * @ordered
     */
    protected NavigationCommandFactory navigationFactory = NAVIGATION_FACTORY_EDEFAULT;

    /**
     * The default value of the '{@link #getSelectionFactory() <em>Selection Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSelectionFactory()
     * @generated NOT
     * @ordered
     */
    protected static final SelectionCommandFactory SELECTION_FACTORY_EDEFAULT = SelectionCommandFactory.getInstance();

    /**
     * The cached value of the '{@link #getSelectionFactory() <em>Selection Factory</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see #getSelectionFactory()
     * @generated
     * @ordered
     */
    protected SelectionCommandFactory selectionFactory = SELECTION_FACTORY_EDEFAULT;
    /**
     * @see net.refractions.udig.project.ui.internal.tool.ToolContext#getDrawFactory()
     */
    public DrawCommandFactory getDrawFactory() {
        return drawFactory;
    }
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public EditCommandFactory getEditFactory() {
        return editFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public NavigationCommandFactory getNavigationFactory() {
        return navigationFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public SelectionCommandFactory getSelectionFactory() {
        return selectionFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public void sendCommand(IDrawCommand command) {
      ((ViewportPane) getRenderManagerInternal().getMapDisplay()).addDrawCommand(command);
      ((ViewportPane) getRenderManagerInternal().getMapDisplay()).repaint();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     */
    public void sendASyncCommand(Command command) {
        if( command instanceof NavCommand )
			getMapInternal().sendCommandASync((NavCommand)command);
        else if( command instanceof EditCommand )
			getMapInternal().sendCommandASync((EditCommand)command);
        else if( command instanceof IDrawCommand )
            sendCommand((IDrawCommand)command);
        else if( command instanceof EditManagerControlCommand )
			getMapInternal().sendCommandASync((EditManagerControlCommand)command);
        else if ( command instanceof MapCommand)
            getMapInternal().sendCommandASync((MapCommand) command);
        else
            getProjectInternal().sendASync(command);
    }

	/**
	 * @see net.refractions.udig.project.ui.tool.IToolContext#sendSyncCommand(net.refractions.udig.project.command.MapCommand)
	 */
	public void sendSyncCommand(Command command) {
        if( command instanceof NavCommand )
			getMapInternal().sendCommandSync((NavCommand)command);
        else if( command instanceof EditCommand )
			getMapInternal().sendCommandSync((EditCommand)command);
        else if( command instanceof IDrawCommand )
            sendCommand((IDrawCommand)command);
        else if( command instanceof EditManagerControlCommand )
			getMapInternal().sendCommandSync((EditManagerControlCommand)command);
        else if ( command instanceof MapCommand)
            getMapInternal().sendCommandSync((MapCommand) command);
        else
            getProjectInternal().sendSync(command);
	}
	
    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated NOT
     *
    public List<LayerPointInfo> getInfo(Point screenLocation) {
        try {
            return getRenderManagerInternal().getInfo(screenLocation);
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }*/

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void eSet(EStructuralFeature eFeature, Object newValue) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case ToolPackage.TOOL_CONTEXT__RENDER_MANAGER_INTERNAL:
                setRenderManagerInternal((RenderManager)newValue);
                return;
            case ToolPackage.TOOL_CONTEXT__MAP_INTERNAL:
                setMapInternal((Map)newValue);
                return;
        }
        eDynamicSet(eFeature, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void eUnset(EStructuralFeature eFeature) {
        switch (eDerivedStructuralFeatureID(eFeature)) {
            case ToolPackage.TOOL_CONTEXT__RENDER_MANAGER_INTERNAL:
                setRenderManagerInternal((RenderManager)null);
                return;
            case ToolPackage.TOOL_CONTEXT__MAP_INTERNAL:
                setMapInternal((Map)null);
                return;
        }
        eDynamicUnset(eFeature);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public String toString() {
        if (eIsProxy()) return super.toString();
        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (drawFactory: ");
        result.append(drawFactory);
        result.append(", editFactory: ");
        result.append(editFactory);
        result.append(", navigationFactory: ");
        result.append(navigationFactory);
        result.append(", selectionFactory: ");
        result.append(selectionFactory);
        result.append(')');
        return result.toString();
    }

    /**
     * @see net.refractions.udig.project.AbstractContext#clone()
     */
    public Object clone() {
        ToolContext tools=new ToolContextImpl();
        tools.setMapInternal(getMapInternal());
        tools.setRenderManagerInternal(getRenderManagerInternal());
        return tools;
    }

    /**
     * @see net.refractions.udig.project.tool.ToolContext#getViewportPane()
     */
    public ViewportPane getViewportPane() {
        return (ViewportPane) getMapDisplay();
    }
    /**
     * @see net.refractions.udig.project.ui.internal.tool.ToolContext#getWorkbench()
     */
    public IWorkbench getWorkbench() {
        return PlatformUI.getWorkbench();
    }
    /**
     * @see net.refractions.udig.project.ui.internal.tool.ToolContext#getDisplay()
     */
    public Display getDisplay() {
        return Display.getDefault();
    }
    /**
     * @see net.refractions.udig.project.ui.internal.tool.ToolContext#log(org.eclipse.core.runtime.Plugin, java.lang.String, int, java.lang.Throwable)
     */
    public void log( Plugin currentPlugin, String message, int severity, Throwable exception ) {
        String ID1 = currentPlugin.getBundle().getSymbolicName();
        currentPlugin.getLog().log(new Status(severity, ID1,
                0, message, exception));
    }

    @Override
    public RenderManager getRenderManagerInternal() {
        return getMapInternal().getRenderManagerInternal();
    }
    
} //Impl
