/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.project.ui.operations.example;

import net.refractions.udig.project.internal.Layer;
import net.refractions.udig.ui.operations.IOp;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;

import com.vividsolutions.jts.geom.Envelope;

/**
 * Displays a summary of the layer in a dialog.
 * 
 * @author jeichar
 * @since 0.6.0
 */
public class LayerSummary implements IOp {
	/**
	 * @see net.refractions.udig.ui.operations.IOp#op(org.eclipse.swt.widgets.Display, java.lang.Object, org.eclipse.core.runtime.IProgressMonitor)
	 */
	public void op(final Display display, Object target, IProgressMonitor monitor) throws Exception {
        final Layer layer=(Layer) target;
        Envelope bounds=layer.getBounds(monitor, layer.getMap().getViewportModel().getCRS());
        final StringBuffer buffer=new StringBuffer();
        buffer.append("Name: "+layer.getName()+"\n");
        buffer.append("ID: "+layer.getID()+"\n");
        buffer.append("z-order: "+layer.getZorder()+"\n");
        buffer.append("Data CRS: "+layer.getCRS(monitor).getName()+"\n");
        buffer.append("Bounds: ("+bounds.getMinX()+","+bounds.getMinY()+")\n");
        buffer.append("            ("+bounds.getMaxX()+","+bounds.getMaxY()+"\n");
        buffer.append("Selection Filter: "+layer.getFilter()+"\n");
        display.asyncExec(new Runnable() {
			public void run() {
		        MessageDialog.openInformation(display.getActiveShell(), "Summary of "+layer.getName(), buffer.toString());
			}
		});
	}

}
