/*
 *    uDig - User Friendly Desktop Internet GIS client
 *    http://udig.refractions.net
 *    (C) 2004, Refractions Research Inc.
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License as published by the Free Software Foundation;
 *    version 2.1 of the License.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 */
package net.refractions.udig.tools.internal;

import net.refractions.udig.project.command.NavigationCommandFactory;
import net.refractions.udig.project.ui.tool.AbstractTool;
import net.refractions.udig.project.ui.tool.ActionTool;

import org.eclipse.swt.widgets.Composite;

/**
 * This class Provides zoom box and click functionality.
 * 
 * @author Jesse Eichar
 * @version $Revision: 1.9 $
 */
public class ZoomExtent extends AbstractTool implements ActionTool {

    NavigationCommandFactory factory=NavigationCommandFactory.getInstance();
    
    /**
     * @see AbstractTool#AbstractTool(int)
     */
    public ZoomExtent() {
        super(ON);
    }

    /**
     * @see net.refractions.udig.project.tool.ActionTool#run()
     */
    public void run() {
    	getContext().sendASyncCommand(factory.createZoomExtentCommand());
    }

    /**
     * @see net.refractions.udig.project.tool.Tool#dispose()
     */
    public void dispose() {
        // Nothing to dispose of.
    }

    /**
     * @see net.refractions.udig.project.tool.Tool#fill(org.eclipse.swt.widgets.Composite)
     */
    public void fill(Composite parent) {
        // Control is a button and extension definition is false so nothing
        // needs to be done.

    }
}