/**
 * 
 */
package net.refractions.udig.ui;

import java.util.List;

import net.refractions.udig.internal.ui.UDIGDragAdapter;
import net.refractions.udig.internal.ui.UDIGDropAdapter;
import net.refractions.udig.internal.ui.UDIGDropTargetProcessor;

import org.eclipse.jface.viewers.StructuredViewer;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.Transfer;

/**
 * @author jones
 *
 */
public class UDIGDragDropUtilities {

	public static void addDragDropSupport(StructuredViewer viewer, Object destination) {
		int dndOperations = DND.DROP_COPY | DND.DROP_MOVE | DND.DROP_LINK;
	    List<Transfer> transfers = UDIGDropTargetProcessor.getTransfers();
	    
	    viewer.addDragSupport(dndOperations, 
	            transfers.toArray(new Transfer[transfers.size()]), 
	            new UDIGDragAdapter(viewer));
	    viewer.addDropSupport(dndOperations, 
	            transfers.toArray(new Transfer[transfers.size()]),
	            new UDIGDropAdapter(viewer,destination));
	}

	public static void addDragSupport(StructuredViewer viewer, Object destination) {
		int dndOperations = DND.DROP_COPY | DND.DROP_MOVE | DND.DROP_LINK | DND.DROP_DEFAULT;
	    List<Transfer> transfers = UDIGDropTargetProcessor.getTransfers();

	    viewer.addDragSupport(dndOperations, 
	            transfers.toArray(new Transfer[transfers.size()]), 
	            new UDIGDragAdapter(viewer));
	}

	public static void addDropSupport(StructuredViewer viewer, Object destination) {
		int dndOperations = DND.DROP_COPY | DND.DROP_MOVE | DND.DROP_LINK | DND.DROP_DEFAULT;
	    List<Transfer> transfers = UDIGDropTargetProcessor.getTransfers();

	    viewer.addDropSupport(dndOperations, 
	            transfers.toArray(new Transfer[transfers.size()]),
	            new UDIGDropAdapter(viewer,destination));
	}

}
