/*
 * uDig - User Friendly Desktop Internet GIS client http://udig.refractions.net (C) 2004,
 * Refractions Research Inc. This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the Free Software
 * Foundation; version 2.1 of the License. This library is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
 */
package net.refractions.udig.ui.palette;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;



/**
 * @author ptozer
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ColourMasterListTester {

	/**
	 * 
	 */
	public ColourMasterListTester() {
		super();
		// TODO Auto-generated constructor stub
	}

	public static void main(String[] args) {
		ColourPaletteMasterList masterList = ColourPaletteMasterList.instance();
		ColourPalette q = masterList.getQualitativePalette();
		//ColourScheme dark = q.getColourSchemeByName("Dark2");
		Map allColourSchemes = q.getAllColourSchemes();
		List<String> allNames = q.getAllSchemeNames();
		Iterator nameIter = allNames.iterator();
		while (nameIter.hasNext()) {
			String schemename = (String)nameIter.next();
			ColourScheme scheme = (ColourScheme)allColourSchemes.get(schemename);
			if(scheme == null) {
				System.out.println("Null scheme");
			} else {
				String name = scheme.getSchemeName();
				System.out.println("Scheme Name:" + name);
				HashMap<String,Color> colours = scheme.getAllColours();
				HashMap<String, ArrayList<String>> suits = scheme.getAllSuitability();
				Set keys = colours.keySet();
				Iterator keyIter = keys.iterator();
				while( keyIter.hasNext()) {
					String letter = (String)keyIter.next();
					Color c = colours.get(letter);
					System.out.println("Colour letter: " + letter + 
									   " Red: " + c.getRed()+ 
									   " Green: " + c.getGreen() + 
									   " Blue: " + c.getBlue() );
					ArrayList<String> suitable = suits.get(letter);
					if(suitable == null) {
						System.out.println("Array is null for letter: " + letter );
					}
					System.out.println("Suitabilities: " + suitable.toString());
				}
			}
		}
		
		//ColourPaletteMasterList palettes = ColourPaletteMasterList.instance();
		ColourPalette qualPalette = masterList.getQualitativePalette();
		List<String> allSchemeNames = qualPalette.getAllSchemeNames();

		Object [] names = allSchemeNames.toArray();
		System.out.println("ALL NAMES: " + ((String)names[0]).toString());
		
		ColourScheme schemeUsed = qualPalette.getColourSchemeByName("Dark2");
		if(schemeUsed == null) {
			System.out.println("Null scheme");
		}else {
			int numberOfLayers = 7;
			String [] colourletters = masterList.getColourLetters(ColourPaletteMasterList.QUALITATIVE_TYPE, numberOfLayers);//{"a", "b", "c", "d", "e", "f", "g"};
			Color [] coloursToUse = new Color[colourletters.length];
	
			for(int i = 0; i < numberOfLayers; i++) {
				Color c = schemeUsed.getColour(colourletters[i]);
				coloursToUse[i] = c;
				System.out.println("Colour letter: " + colourletters[i] + 
						   " Red: " + c.getRed()+ 
						   " Green: " + c.getGreen() + 
						   " Blue: " + c.getBlue() );
				//System.out.println("Colour: " + (c.getBlue()));
			}
			
			for(int i = 0; i < numberOfLayers; i++) {
				String colourLetter = masterList.getColourLetterByLayerNumber(masterList.QUALITATIVE_TYPE, i);
				Color c = schemeUsed.getColour(colourLetter);
				coloursToUse[i] = c;
				System.out.println("Colour letter: " + colourLetter + 
						   " Red: " + c.getRed()+ 
						   " Green: " + c.getGreen() + 
						   " Blue: " + c.getBlue() );
				//System.out.println("Colour: " + (c.getBlue()));
			}
			
		}
		
		
		
	}
}
